//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using System.Collections.Generic;
			using System.Globalization;
			using System;
			using System.IO;
			using System.Text;
			using System.Xml;
			
		#endregion
		
	public class ControlConfigReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private bool m_bMotfCapable;
			protected byte[] m_byteCorrFile1;
			protected byte[] m_byteCorrFile2;
			protected byte[] m_byteLaserFile;
			protected byte[] m_byteLensFile;
			protected byte[] m_bytePerformanceFile;
			protected byte[] m_byteUserFile;
			private float m_fMotfCalGain;
			private float m_fMotfEncoderCal;
			private int m_iCardType;
			private UInt16 m_iInterlockConfig;
			private int m_iJumpPeriodOffset;
			private int m_iMarkPeriodOffset;
			private uint m_iServoConfig;
			private short m_sMotfDirection;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			private uint m_uiAxisDACRange;
			private uint m_uiPipelineDelay;
			private UInt16 m_usMotfMode;
			public const uint Opcode = 5;
			private CultureInfo usCulture;
		#endregion
		
		#region Constructors
		
			public ControlConfigReader ()
			
			{
				this.usCulture = new CultureInfo ("en-US", false);
				this.m_strDefaultFileName = "ControlConfig.xml";
				this.m_strType = "ControlConfigData";
				this.m_strVersion = "1.0";
				this.m_iCardType = 8;
				this.m_byteCorrFile1 = new ASCIIEncoding ().GetBytes ("LECCorr1");
				this.m_byteCorrFile2 = new ASCIIEncoding ().GetBytes ("LECCorr2");
				this.m_byteLaserFile = new ASCIIEncoding ().GetBytes ("LECLaser");
				this.m_byteLensFile = new ASCIIEncoding ().GetBytes ("LECLens");
				this.m_byteUserFile = new ASCIIEncoding ().GetBytes ("LECUser");
				this.m_bytePerformanceFile = new ASCIIEncoding ().GetBytes ("LECGLobalConfig");
				this.m_bMotfCapable = true;
				this.m_fMotfEncoderCal = 1F;
				this.m_fMotfCalGain = 1F;
				this.m_uiAxisDACRange = 1;
			}
			
			
			static ControlConfigReader ()
			
			{
				ControlConfigReader.m_strDisplayName = "Controller Configuration";
			}
			
		#endregion
		
		#region Properties
		
			public uint AxisDACRange
			
			{
				get
				{
					return this.m_uiAxisDACRange;
				}
				set
				{
					this.m_uiAxisDACRange = value;
				}
			}
			
			
			public int CardType
			
			{
				get
				{
					return this.m_iCardType;
				}
			}
			
			
			public string CorrFile1
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteCorrFile1, 0, ArrayEx.ValueLength (this.m_byteCorrFile1, 0, this.m_byteCorrFile1.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteCorrFile1 = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public string CorrFile2
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteCorrFile2, 0, ArrayEx.ValueLength (this.m_byteCorrFile2, 0, this.m_byteCorrFile2.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteCorrFile2 = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return ControlConfigReader.m_strDisplayName;
				}
			}
			
			
			public UInt16 InterlockConfig
			
			{
				get
				{
					return this.m_iInterlockConfig;
				}
				set
				{
					this.m_iInterlockConfig = value;
				}
			}
			
			
			public int JumpPeriodOffset
			
			{
				get
				{
					return this.m_iJumpPeriodOffset;
				}
				set
				{
					this.m_iJumpPeriodOffset = value;
				}
			}
			
			
			public string LaserFile
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteLaserFile, 0, ArrayEx.ValueLength (this.m_byteLaserFile, 0, this.m_byteLaserFile.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteLaserFile = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public string LensFile
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteLensFile, 0, ArrayEx.ValueLength (this.m_byteLensFile, 0, this.m_byteLensFile.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteLensFile = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public int MarkPeriodOffset
			
			{
				get
				{
					return this.m_iMarkPeriodOffset;
				}
				set
				{
					this.m_iMarkPeriodOffset = value;
				}
			}
			
			
			public float MotfCalGain
			
			{
				get
				{
					return this.m_fMotfCalGain;
				}
				set
				{
					this.m_fMotfCalGain = value;
				}
			}
			
			
			public bool MotfCapable
			
			{
				get
				{
					return this.m_bMotfCapable;
				}
				set
				{
					this.m_bMotfCapable = value;
				}
			}
			
			
			public short MotfDirection
			
			{
				get
				{
					return this.m_sMotfDirection;
				}
				set
				{
					this.m_sMotfDirection = value;
				}
			}
			
			
			public float MotfEncoderCal
			
			{
				get
				{
					return this.m_fMotfEncoderCal;
				}
				set
				{
					this.m_fMotfEncoderCal = value;
				}
			}
			
			
			public UInt16 MotfMode
			
			{
				get
				{
					return this.m_usMotfMode;
				}
				set
				{
					this.m_usMotfMode = value;
				}
			}
			
			
			public string PerformanceFile
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_bytePerformanceFile, 0, ArrayEx.ValueLength (this.m_bytePerformanceFile, 0, this.m_bytePerformanceFile.Length, Encoding.ASCII));
				}
				set
				{
					this.m_bytePerformanceFile = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public uint PipelineDelay
			
			{
				get
				{
					return this.m_uiPipelineDelay;
				}
				set
				{
					this.m_uiPipelineDelay = value;
				}
			}
			
			
			public uint ServoConfig
			
			{
				get
				{
					return this.m_iServoConfig;
				}
				set
				{
					this.m_iServoConfig = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public string UserFile
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteUserFile, 0, ArrayEx.ValueLength (this.m_byteUserFile, 0, this.m_byteUserFile.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteUserFile = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				string string2;
				int i1;
				Dictionary<String, Int32> dictionary21 = ((Dictionary<String, Int32>) null);
				while (true)
				{
					while (pxmlRead.NodeType == XmlNodeType.Element)
					{
						if ((string2 = pxmlRead.Name) != null)
						{
							if (dictionary21 == null)
							{
								dictionary21 = new Dictionary<String, Int32> (18);
								dictionary21.Add ("Data", 0);
								dictionary21.Add ("CorrFile1", 1);
								dictionary21.Add ("CorrFile2", 2);
								dictionary21.Add ("LaserFile", 3);
								dictionary21.Add ("LensFile", 4);
								dictionary21.Add ("UserFile", 5);
								dictionary21.Add ("PerformanceFile", 6);
								dictionary21.Add ("MotfCapable", 7);
								dictionary21.Add ("MotfEncoderCal", 8);
								dictionary21.Add ("MotfCalGain", 9);
								dictionary21.Add ("MotfMode", 10);
								dictionary21.Add ("MotfDirection", 11);
								dictionary21.Add ("AxisDACRange", 12);
								dictionary21.Add ("JumpPeriodOffset", 13);
								dictionary21.Add ("MarkPeriodOffset", 14);
								dictionary21.Add ("ServoConfig", 15);
								dictionary21.Add ("IntlockConfig", 16);
								dictionary21.Add ("LaserPipelineDelay", 17);
							}
							if (dictionary21.TryGetValue (string2, out i1))
							{
								switch (i1)
								{
									case 0:
									
									{
											string1 = pxmlRead.GetAttribute ("type");
											if (string1.CompareTo (this.Type) != 0)
											{
												throw new FormatException (("Parsing " + string1 + " when expecting " + this.Type));
											}
											bool b1 = pxmlRead.Read ();
											continue;
									}
									case 1:
									
									{
											bool b2 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.CorrFile1 = pxmlRead.Value;
											continue;
									}
									case 2:
									
									{
											bool b3 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.CorrFile2 = pxmlRead.Value;
											continue;
									}
									case 3:
									
									{
											bool b4 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserFile = pxmlRead.Value;
											continue;
									}
									case 4:
									
									{
											bool b5 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LensFile = pxmlRead.Value;
											continue;
									}
									case 5:
									
									{
											bool b6 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.UserFile = pxmlRead.Value;
											continue;
									}
									case 6:
									
									{
											bool b7 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.PerformanceFile = pxmlRead.Value;
											continue;
									}
									case 7:
									
									{
											bool b8 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MotfCapable = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 8:
									
									{
											bool b9 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MotfEncoderCal = ((float) Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture)));
											continue;
									}
									case 9:
									
									{
											bool b10 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MotfCalGain = ((float) Convert.ToDouble (pxmlRead.Value));
											continue;
									}
									case 10:
									
									{
											bool b11 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MotfMode = Convert.ToUInt16 (pxmlRead.Value);
											continue;
									}
									case 11:
									
									{
											bool b12 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MotfDirection = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 12:
									
									{
											bool b13 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.AxisDACRange = Convert.ToUInt32 (pxmlRead.Value);
											continue;
									}
									case 13:
									
									{
											bool b14 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.JumpPeriodOffset = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 14:
									
									{
											bool b15 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MarkPeriodOffset = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 15:
									
									{
											bool b16 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.ServoConfig = Convert.ToUInt32 (pxmlRead.Value, 16);
											continue;
									}
									case 16:
									
									{
											bool b17 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.InterlockConfig = Convert.ToUInt16 (pxmlRead.Value, 16);
											continue;
									}
									case 17:
									
									{
											bool b18 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.PipelineDelay = Convert.ToUInt32 (pxmlRead.Value);
											continue;
									}
								}
							}
						}
						bool b19 = pxmlRead.Read ();
					}
					if (! pxmlRead.Read ())
					{
						return;
					}
				}
			}
			
		#endregion
	}
	
}

