//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using System.Collections.Generic;
			using System.Globalization;
			using System.IO;
			using System;
			using System.Text;
			using System.Xml;
			
		#endregion
		
	public class LensConfigReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private bool m_bCalibrateFlag;
			protected byte[] m_byteLensName;
			private float m_fTable1Rotation;
			private float m_fTable1XGain;
			private float m_fTable1YGain;
			private float m_fTable2Rotation;
			private float m_fTable2XGain;
			private float m_fTable2YGain;
			private int m_iAperture;
			private int m_iFocalLength;
			private int m_iKFactor;
			private int m_iZKFactor;
			private short m_sTable1XOffset;
			private short m_sTable1YOffset;
			private short m_sTable2XOffset;
			private short m_sTable2YOffset;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			private short m_sZMode;
			public const uint Opcode = 2;
			private CultureInfo usCulture;
		#endregion
		
		#region Constructors
		
			public LensConfigReader ()
			
			{
				this.usCulture = new CultureInfo ("en-US", false);
				this.m_strDefaultFileName = "LensConfig.xml";
				this.m_strType = "LensConfigData";
				this.m_strVersion = "1.0";
				this.m_byteLensName = new UnicodeEncoding ().GetBytes ("Default");
				this.m_iKFactor = 500;
				this.m_iZKFactor = 500;
				this.m_iFocalLength = 163;
				this.m_iAperture = 15;
				this.m_fTable1XGain = 1F;
				this.m_fTable1YGain = 1F;
				this.m_fTable2XGain = 1F;
				this.m_fTable2YGain = 1F;
			}
			
			
			static LensConfigReader ()
			
			{
				LensConfigReader.m_strDisplayName = "Lens Configuration";
			}
			
		#endregion
		
		#region Properties
		
			public int Aperture
			
			{
				get
				{
					return this.m_iAperture;
				}
				set
				{
					this.m_iAperture = value;
				}
			}
			
			
			public bool CalibrateFlag
			
			{
				get
				{
					return this.m_bCalibrateFlag;
				}
				set
				{
					this.m_bCalibrateFlag = value;
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return LensConfigReader.m_strDisplayName;
				}
			}
			
			
			public int FocalLength
			
			{
				get
				{
					return this.m_iFocalLength;
				}
				set
				{
					this.m_iFocalLength = value;
				}
			}
			
			
			public int KFactor
			
			{
				get
				{
					return this.m_iKFactor;
				}
				set
				{
					this.m_iKFactor = value;
				}
			}
			
			
			public string LensName
			
			{
				get
				{
					byte[] byteArray1 = Encoding.Convert (Encoding.Unicode, Encoding.ASCII, this.m_byteLensName);
					return Encoding.ASCII.GetString (byteArray1, 0, ArrayEx.ValueLength (byteArray1, 0, byteArray1.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteLensName = new UnicodeEncoding ().GetBytes (value);
				}
			}
			
			
			public float Table1Rotation
			
			{
				get
				{
					return this.m_fTable1Rotation;
				}
				set
				{
					this.m_fTable1Rotation = value;
				}
			}
			
			
			public float Table1XGain
			
			{
				get
				{
					return this.m_fTable1XGain;
				}
				set
				{
					this.m_fTable1XGain = value;
				}
			}
			
			
			public short Table1XOffset
			
			{
				get
				{
					return this.m_sTable1XOffset;
				}
				set
				{
					this.m_sTable1XOffset = value;
				}
			}
			
			
			public float Table1YGain
			
			{
				get
				{
					return this.m_fTable1YGain;
				}
				set
				{
					this.m_fTable1YGain = value;
				}
			}
			
			
			public short Table1YOffset
			
			{
				get
				{
					return this.m_sTable1YOffset;
				}
				set
				{
					this.m_sTable1YOffset = value;
				}
			}
			
			
			public float Table2Rotation
			
			{
				get
				{
					return this.m_fTable2Rotation;
				}
				set
				{
					this.m_fTable2Rotation = value;
				}
			}
			
			
			public float Table2XGain
			
			{
				get
				{
					return this.m_fTable2XGain;
				}
				set
				{
					this.m_fTable2XGain = value;
				}
			}
			
			
			public short Table2XOffset
			
			{
				get
				{
					return this.m_sTable2XOffset;
				}
				set
				{
					this.m_sTable2XOffset = value;
				}
			}
			
			
			public float Table2YGain
			
			{
				get
				{
					return this.m_fTable2YGain;
				}
				set
				{
					this.m_fTable2YGain = value;
				}
			}
			
			
			public short Table2YOffset
			
			{
				get
				{
					return this.m_sTable2YOffset;
				}
				set
				{
					this.m_sTable2YOffset = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
			
			public int ZKFactor
			
			{
				get
				{
					return this.m_iZKFactor;
				}
				set
				{
					this.m_iZKFactor = value;
				}
			}
			
			
			public short ZMode
			
			{
				get
				{
					return this.m_sZMode;
				}
				set
				{
					this.m_sZMode = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public override bool Equals (object obj)
			
			{
				if (obj == null)
				{
					return false;
				}
				if (base.GetType () != obj.GetType ())
				{
					return false;
				}
				LensConfigReader lensConfigReader1 = ((LensConfigReader) obj);
				if (this.Table1Rotation != lensConfigReader1.Table1Rotation)
				{
					return false;
				}
				else if (this.Table2Rotation != lensConfigReader1.Table2Rotation)
				{
					return false;
				}
				else if (this.Aperture != lensConfigReader1.Aperture)
				{
					return false;
				}
				else if (this.ZMode != lensConfigReader1.ZMode)
				{
					return false;
				}
				else if (this.CalibrateFlag != lensConfigReader1.CalibrateFlag)
				{
					return false;
				}
				else if (this.Table1XGain != lensConfigReader1.Table1XGain)
				{
					return false;
				}
				else if (this.Table1XOffset != lensConfigReader1.Table1XOffset)
				{
					return false;
				}
				else if (this.Table1YGain != lensConfigReader1.Table1YGain)
				{
					return false;
				}
				else if (this.Table1YOffset != lensConfigReader1.Table1YOffset)
				{
					return false;
				}
				else if (this.FocalLength != lensConfigReader1.FocalLength)
				{
					return false;
				}
				else if (this.KFactor != lensConfigReader1.KFactor)
				{
					return false;
				}
				else if (this.LensName.CompareTo (lensConfigReader1.LensName) != 0)
				{
					return false;
				}
				else if (this.Table2XGain != lensConfigReader1.Table2XGain)
				{
					return false;
				}
				else if (this.Table2XOffset != lensConfigReader1.Table2XOffset)
				{
					return false;
				}
				else if (this.Table2YGain != lensConfigReader1.Table2YGain)
				{
					return false;
				}
				else if (this.Table2YOffset != lensConfigReader1.Table2YOffset)
				{
					return false;
				}
				else if (base.ServerName.CompareTo (lensConfigReader1.ServerName) != 0)
				{
					return false;
				}
				else if (this.ZKFactor == lensConfigReader1.ZKFactor)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			
			public bool EqualsTable1 (object obj)
			
			{
				if (obj == null)
				{
					return false;
				}
				if (base.GetType () != obj.GetType ())
				{
					return false;
				}
				LensConfigReader lensConfigReader1 = ((LensConfigReader) obj);
				if (this.Table1Rotation != lensConfigReader1.Table1Rotation)
				{
					return false;
				}
				else if (this.Table1XGain != lensConfigReader1.Table1XGain)
				{
					return false;
				}
				else if (this.Table1XOffset != lensConfigReader1.Table1XOffset)
				{
					return false;
				}
				else if (this.Table1YGain != lensConfigReader1.Table1YGain)
				{
					return false;
				}
				else if (this.Table1YOffset == lensConfigReader1.Table1YOffset)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			
			public bool EqualsTable2 (object obj)
			
			{
				if (obj == null)
				{
					return false;
				}
				if (base.GetType () != obj.GetType ())
				{
					return false;
				}
				LensConfigReader lensConfigReader1 = ((LensConfigReader) obj);
				if (this.Table2Rotation != lensConfigReader1.Table2Rotation)
				{
					return false;
				}
				else if (this.Table2XGain != lensConfigReader1.Table2XGain)
				{
					return false;
				}
				else if (this.Table2XOffset != lensConfigReader1.Table2XOffset)
				{
					return false;
				}
				else if (this.Table2YGain != lensConfigReader1.Table2YGain)
				{
					return false;
				}
				else if (this.Table2YOffset == lensConfigReader1.Table2YOffset)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				if (pstrData.Length == 0)
				{
					return;
				}
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				string string2;
				int i1;
				Dictionary<String, Int32> dictionary21 = ((Dictionary<String, Int32>) null);
				while (true)
				{
					while (pxmlRead.NodeType == XmlNodeType.Element)
					{
						if ((string2 = pxmlRead.Name) != null)
						{
							if (dictionary21 == null)
							{
								dictionary21 = new Dictionary<String, Int32> (18);
								dictionary21.Add ("Data", 0);
								dictionary21.Add ("LensName", 1);
								dictionary21.Add ("CalFlag", 2);
								dictionary21.Add ("KFactor", 3);
								dictionary21.Add ("ZKFactor", 4);
								dictionary21.Add ("FocalLen", 5);
								dictionary21.Add ("Aperture", 6);
								dictionary21.Add ("ZMode", 7);
								dictionary21.Add ("Tbl1XOff", 8);
								dictionary21.Add ("Tbl1YOff", 9);
								dictionary21.Add ("Tbl2XOff", 10);
								dictionary21.Add ("Tbl2YOff", 11);
								dictionary21.Add ("Tbl1XGain", 12);
								dictionary21.Add ("Tbl1YGain", 13);
								dictionary21.Add ("Tbl2XGain", 14);
								dictionary21.Add ("Tbl2YGain", 15);
								dictionary21.Add ("Tbl1Rotation", 16);
								dictionary21.Add ("Tbl2Rotation", 17);
							}
							if (dictionary21.TryGetValue (string2, out i1))
							{
								switch (i1)
								{
									case 0:
									
									{
											string1 = pxmlRead.GetAttribute ("type");
											if (string1.CompareTo (this.Type) != 0)
											{
												throw new FormatException (("Parsing " + string1 + " when expecting " + this.Type));
											}
											bool b1 = pxmlRead.Read ();
											continue;
									}
									case 1:
									
									{
											bool b2 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LensName = pxmlRead.Value;
											continue;
									}
									case 2:
									
									{
											bool b3 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.CalibrateFlag = Convert.ToBoolean (pxmlRead.Value);
											continue;
									}
									case 3:
									
									{
											bool b4 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.KFactor = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 4:
									
									{
											bool b5 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.ZKFactor = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 5:
									
									{
											bool b6 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.FocalLength = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 6:
									
									{
											bool b7 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Aperture = Convert.ToInt32 (pxmlRead.Value);
											continue;
									}
									case 7:
									
									{
											bool b8 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.ZMode = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 8:
									
									{
											bool b9 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table1XOffset = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 9:
									
									{
											bool b10 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table1YOffset = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 10:
									
									{
											bool b11 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table2XOffset = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 11:
									
									{
											bool b12 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table2YOffset = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 12:
									
									{
											bool b13 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table1XGain = Convert.ToSingle (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 13:
									
									{
											bool b14 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table1YGain = Convert.ToSingle (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 14:
									
									{
											bool b15 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table2XGain = Convert.ToSingle (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 15:
									
									{
											bool b16 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table2YGain = Convert.ToSingle (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 16:
									
									{
											bool b17 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table1Rotation = Convert.ToSingle (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 17:
									
									{
											bool b18 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.Table2Rotation = Convert.ToSingle (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
								}
							}
						}
						bool b19 = pxmlRead.Read ();
					}
					if (! pxmlRead.Read ())
					{
						return;
					}
				}
			}
			
			public override int GetHashCode ()
			
			{
				int i1 = 17;
				i1 = ((int) ((37 * i1) + this.Table1Rotation.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table2Rotation.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Aperture.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.ZMode.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.CalibrateFlag.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table1XGain.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table1XOffset.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table1YGain.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table1YOffset.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.FocalLength.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.KFactor.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.LensName.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table2XGain.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table2XOffset.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table2YGain.GetHashCode ()));
				i1 = ((int) ((37 * i1) + this.Table2YOffset.GetHashCode ()));
				i1 = ((int) ((37 * i1) + base.ServerName.GetHashCode ()));
				return ((int) ((37 * i1) + this.ZKFactor.GetHashCode ()));
			}
			
		#endregion
	}
	
}

