//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.IO;
			using System.Text;
			
		#endregion
		
	public class StatInfoReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			private bool m_bXPositionAck;
			private bool m_bXPowerStatus;
			private bool m_bXTemperatureStatus;
			private bool m_bYPositionAck;
			private bool m_bYPowerStatus;
			private bool m_bYTemperatureStatus;
			protected byte[] m_byteStreamVersion;
			private short m_sControllerTemperatureStatus;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			private short m_sXActualPosition;
			private short m_sXPosition;
			private short m_sYActualPosition;
			private short m_sYPosition;
			private int m_uiJobDataCounter;
			private uint m_usCurrentDIO;
			private UInt16 m_usInterlock;
			private UInt16 m_usJobMarker;
			public const uint Opcode = 7;
		#endregion
		
		#region Constructors
		
			public StatInfoReader ()
			
			{
				this.m_strDefaultFileName = "";
				this.m_strType = "StatInfoData";
				this.m_strVersion = "1.0";
				this.m_byteStreamVersion = new ASCIIEncoding ().GetBytes ("StreamVersion0x03d2");
			}
			
			
			static StatInfoReader ()
			
			{
				StatInfoReader.m_strDisplayName = "Status Information";
			}
			
		#endregion
		
		#region Properties
		
			public short ControllerTemperatureStatus
			
			{
				get
				{
					return this.m_sControllerTemperatureStatus;
				}
				set
				{
					this.m_sControllerTemperatureStatus = value;
				}
			}
			
			
			public uint CurrentDIO
			
			{
				get
				{
					return this.m_usCurrentDIO;
				}
				set
				{
					this.m_usCurrentDIO = value;
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return StatInfoReader.m_strDisplayName;
				}
			}
			
			
			public UInt16 Interlock
			
			{
				get
				{
					return this.m_usInterlock;
				}
				set
				{
					this.m_usInterlock = value;
				}
			}
			
			
			public int JobDataCounter
			
			{
				get
				{
					return this.m_uiJobDataCounter;
				}
				set
				{
					this.m_uiJobDataCounter = value;
				}
			}
			
			
			public UInt16 JobMarker
			
			{
				get
				{
					return this.m_usJobMarker;
				}
				set
				{
					this.m_usJobMarker = value;
				}
			}
			
			
			public string StreamVersion
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteStreamVersion, 0, this.m_byteStreamVersion.Length);
				}
				set
				{
					this.m_byteStreamVersion = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
			
			public short XActualPosition
			
			{
				get
				{
					return this.m_sXActualPosition;
				}
				set
				{
					this.m_sXActualPosition = value;
				}
			}
			
			
			public short XPosition
			
			{
				get
				{
					return this.m_sXPosition;
				}
				set
				{
					this.m_sXPosition = value;
				}
			}
			
			
			public bool XPositionAck
			
			{
				get
				{
					return this.m_bXPositionAck;
				}
				set
				{
					this.m_bXPositionAck = value;
				}
			}
			
			
			public bool XPowerStatus
			
			{
				get
				{
					return this.m_bXPowerStatus;
				}
				set
				{
					this.m_bXPowerStatus = value;
				}
			}
			
			
			public bool XTemperatureStatus
			
			{
				get
				{
					return this.m_bXTemperatureStatus;
				}
				set
				{
					this.m_bXTemperatureStatus = value;
				}
			}
			
			
			public short YActualPosition
			
			{
				get
				{
					return this.m_sYActualPosition;
				}
				set
				{
					this.m_sYActualPosition = value;
				}
			}
			
			
			public short YPosition
			
			{
				get
				{
					return this.m_sYPosition;
				}
				set
				{
					this.m_sYPosition = value;
				}
			}
			
			
			public bool YPositionAck
			
			{
				get
				{
					return this.m_bYPositionAck;
				}
				set
				{
					this.m_bYPositionAck = value;
				}
			}
			
			
			public bool YPowerStatus
			
			{
				get
				{
					return this.m_bYPowerStatus;
				}
				set
				{
					this.m_bYPowerStatus = value;
				}
			}
			
			
			public bool YTemperatureStatus
			
			{
				get
				{
					return this.m_bYTemperatureStatus;
				}
				set
				{
					this.m_bYTemperatureStatus = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void FromXML (StreamReader poData)
			
			{
			}
			
			public virtual void FromXML (string pstrData)
			
			{
			}
			
		#endregion
	}
	
}

