//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using System;
			using System.IO;
			using System.Net;
			using System.Text;
			using System.Xml;
			
		#endregion
		
	public class SysInfoReader : BaseConfig, IBaseXmlReader
	
	{
		
		#region Fields
			protected byte[] m_byteApplicationVersion;
			protected byte[] m_byteConnectedJobName;
			protected byte[] m_byteFPGAFirmwareVersion;
			protected byte[] m_byteFriendlyName;
			protected byte[] m_byteMACAddress;
			protected byte[] m_byteManufactureSerialNumber;
			protected byte[] m_byteMarkHeadSerialNumber;
			protected byte[] m_byteObjectExtensionVersion;
			protected byte[] m_bytePermStoragePath;
			protected byte[] m_bytePlatformVersion;
			protected byte[] m_byteStreamVersion;
			protected byte[] m_byteUSBStoragePath;
			private IPAddress m_ipAddress;
			private IPAddress m_ipConnectedAddress;
			private IPAddress m_ipNetMask;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			private uint m_uiFreePermStorage;
			private uint m_uiFreeTempStorage;
			private uint m_uiFreeUSBStorage;
			private uint m_uiLastError;
			private uint m_uiNetAssignType;
			private uint m_uiStateCode;
			private ulong m_ulTCPPortNumber;
			public const uint Opcode = 1;
			public const uint State_Available = uint.MinValue;
			public const uint State_ClientLocal = 4;
			public const uint State_ClientSerial = 2;
			public const uint State_ClientTCP = 1;
			public const uint State_Error = 256;
			public const uint State_FPGAFirmwareError = 1024;
			public const uint State_NotAvailable = 128;
			public const uint State_NotFound = 512;
			public const uint State_Pausing = 32;
			public const uint State_Restarting = 8;
			public const uint State_Waiting = 16;
			public const uint State_WaitingTCP = 64;
		#endregion
		
		#region Constructors
		
			public SysInfoReader ()
			
			{
				this.m_strDefaultFileName = "";
				this.m_strType = "SysInfoData";
				this.m_strVersion = "1.0";
				this.m_byteStreamVersion = new ASCIIEncoding ().GetBytes ("StreamVersion0x03d2");
				this.m_byteManufactureSerialNumber = new ASCIIEncoding ().GetBytes ("0000000000000000");
				this.m_bytePlatformVersion = new ASCIIEncoding ().GetBytes ("4.2.0");
				this.m_byteApplicationVersion = new ASCIIEncoding ().GetBytes ("1.0.0");
				this.m_byteObjectExtensionVersion = new ASCIIEncoding ().GetBytes ("1.0.0");
				this.m_byteFPGAFirmwareVersion = new ASCIIEncoding ().GetBytes ("20060101");
				this.m_bytePermStoragePath = new ASCIIEncoding ().GetBytes ("");
				this.m_byteUSBStoragePath = new ASCIIEncoding ().GetBytes ("");
				this.m_uiFreeTempStorage = 24000;
				this.m_uiFreePermStorage = 32000;
				this.m_byteMACAddress = new ASCIIEncoding ().GetBytes ("00:00:00:00:00:00");
				this.m_ipNetMask = IPAddress.Parse ("255.255.255.255");
				this.m_uiNetAssignType = 1;
				this.m_ipAddress = IPAddress.Parse ("127.0.0.1");
				this.m_ipConnectedAddress = IPAddress.Parse ("0.0.0.0");
				this.m_byteFriendlyName = new UnicodeEncoding ().GetBytes ("LECDevice");
				this.m_byteConnectedJobName = new UnicodeEncoding ().GetBytes ("");
				this.m_ulTCPPortNumber = 8631;
				this.m_byteMarkHeadSerialNumber = new ASCIIEncoding ().GetBytes ("0000000000000000");
			}
			
			
			static SysInfoReader ()
			
			{
				SysInfoReader.m_strDisplayName = "System Information";
			}
			
		#endregion
		
		#region Properties
		
			public IPAddress Address
			
			{
				get
				{
					return this.m_ipAddress;
				}
				set
				{
					this.m_ipAddress = value;
				}
			}
			
			
			public string ApplicationVersion
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteApplicationVersion, 0, ArrayEx.ValueLength (this.m_byteApplicationVersion, 0, this.m_byteApplicationVersion.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteApplicationVersion = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public IPAddress ConnectedAddress
			
			{
				get
				{
					return this.m_ipConnectedAddress;
				}
				set
				{
					this.m_ipConnectedAddress = value;
				}
			}
			
			
			public string ConnectedJobName
			
			{
				get
				{
					byte[] byteArray1 = Encoding.Convert (Encoding.Unicode, Encoding.ASCII, this.m_byteConnectedJobName);
					return Encoding.ASCII.GetString (byteArray1, 0, ArrayEx.ValueLength (byteArray1, 0, byteArray1.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteConnectedJobName = new UnicodeEncoding ().GetBytes (value);
				}
			}
			
			
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return SysInfoReader.m_strDisplayName;
				}
			}
			
			
			public string FPGAFirmwareVersion
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteFPGAFirmwareVersion, 0, ArrayEx.ValueLength (this.m_byteFPGAFirmwareVersion, 0, this.m_byteFPGAFirmwareVersion.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteFPGAFirmwareVersion = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public uint FreePermStorage
			
			{
				get
				{
					return this.m_uiFreePermStorage;
				}
				set
				{
					this.m_uiFreePermStorage = value;
				}
			}
			
			
			public uint FreeTempStorage
			
			{
				get
				{
					return this.m_uiFreeTempStorage;
				}
				set
				{
					this.m_uiFreeTempStorage = value;
				}
			}
			
			
			public uint FreeUSBStorage
			
			{
				get
				{
					return this.m_uiFreeUSBStorage;
				}
				set
				{
					this.m_uiFreeUSBStorage = value;
				}
			}
			
			
			public string FriendlyName
			
			{
				get
				{
					byte[] byteArray1 = Encoding.Convert (Encoding.Unicode, Encoding.ASCII, this.m_byteFriendlyName);
					string string1 = Encoding.ASCII.GetString (byteArray1, 0, ArrayEx.ValueLength (byteArray1, 0, byteArray1.Length, Encoding.ASCII));
					return string1.TrimEnd (new char[1]);
				}
				set
				{
					this.m_byteFriendlyName = new UnicodeEncoding ().GetBytes (value);
				}
			}
			
			
			public uint LastError
			
			{
				get
				{
					return this.m_uiLastError;
				}
				set
				{
					this.m_uiLastError = value;
				}
			}
			
			
			public string ManufactureSerialNumber
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteManufactureSerialNumber, 0, ArrayEx.ValueLength (this.m_byteManufactureSerialNumber, 0, this.m_byteManufactureSerialNumber.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteManufactureSerialNumber = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public string MarkHeadSerialNumber
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteMarkHeadSerialNumber, 0, ArrayEx.ValueLength (this.m_byteMarkHeadSerialNumber, 0, this.m_byteMarkHeadSerialNumber.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteMarkHeadSerialNumber = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public uint NetAssignType
			
			{
				get
				{
					return this.m_uiNetAssignType;
				}
				set
				{
					this.m_uiNetAssignType = value;
				}
			}
			
			
			public IPAddress NetMask
			
			{
				get
				{
					return this.m_ipNetMask;
				}
				set
				{
					this.m_ipNetMask = value;
				}
			}
			
			
			public string NodeMACAddress
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteMACAddress, 0, ArrayEx.ValueLength (this.m_byteMACAddress, 0, this.m_byteMACAddress.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteMACAddress = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public string ObjectExtensionVersion
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteObjectExtensionVersion, 0, ArrayEx.ValueLength (this.m_byteObjectExtensionVersion, 0, this.m_byteObjectExtensionVersion.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteObjectExtensionVersion = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public string PermStoragePath
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_bytePermStoragePath, 0, ArrayEx.ValueLength (this.m_bytePermStoragePath, 0, this.m_bytePermStoragePath.Length, Encoding.ASCII));
				}
				set
				{
					this.m_bytePermStoragePath = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public string PlatformVersion
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_bytePlatformVersion, 0, ArrayEx.ValueLength (this.m_bytePlatformVersion, 0, this.m_bytePlatformVersion.Length, Encoding.ASCII));
				}
				set
				{
					this.m_bytePlatformVersion = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public uint StateCode
			
			{
				get
				{
					return this.m_uiStateCode;
				}
				set
				{
					this.m_uiStateCode = value;
				}
			}
			
			
			public string StreamVersion
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteStreamVersion, 0, ArrayEx.ValueLength (this.m_byteStreamVersion, 0, this.m_byteStreamVersion.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteStreamVersion = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public ulong TCPPortNumber
			
			{
				get
				{
					return this.m_ulTCPPortNumber;
				}
				set
				{
					this.m_ulTCPPortNumber = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public string USBStoragePath
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.m_byteUSBStoragePath, 0, ArrayEx.ValueLength (this.m_byteUSBStoragePath, 0, this.m_byteUSBStoragePath.Length, Encoding.ASCII));
				}
				set
				{
					this.m_byteUSBStoragePath = new ASCIIEncoding ().GetBytes (value);
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				string string2;
				
			L_0000:
				
				{
				}
				while (true)
				{
					while (true)
					{
						if (pxmlRead.NodeType != XmlNodeType.Element)
						{
							if (! pxmlRead.Read ())
							{
								return;
							}
							goto L_0000;
						}
						if (((string2 = pxmlRead.Name) == null) || (string2 != "Data"))
						{
							break;
						}
						string1 = pxmlRead.GetAttribute ("type");
						if (string1.CompareTo (this.Type) != 0)
						{
							throw new FormatException (("Parsing " + string1 + " when expecting " + this.Type));
						}
						bool b1 = pxmlRead.Read ();
					}
					bool b2 = pxmlRead.Read ();
				}
			}
			
		#endregion
	}
	
}

