//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:22:12
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.FTP

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Text;
			
		#endregion
		
	public class DataConnection
	
	{
		
		#region Fields
			private ASCIIEncoding ASCII;
			public event DataReceivedHandler DataReceived;
			public event DataSentHandler DataSent;
			private string localIPAddress;
			private long m_AppendFrom;
			private string m_Data;
			private Socket m_DataSocket;
			private bool m_DownloadToFile;
			private FileModes m_FileMode;
			private string m_Filename;
			private FileStream m_FileStream;
			private bool m_Passive;
			private int m_Port;
			private IPEndPoint m_RemoteEndPoint;
			private StreamDirections m_StreamDirection;
			private long m_TransferredBytes;
		#endregion
		
		#region Nested Types
		
			public delegate void DataReceivedHandler (int ByteLen);
			
			public delegate void DataSentHandler (int ByteLen);
			
			public enum FileModes
			
			{
				Overwrite = 0, 
				Append = 1, 
			}
			
			
			public enum StreamDirections
			
			{
				Download = 0, 
				Upload = 1, 
			}
			
		#endregion
		
		#region Constructors
		
			public DataConnection ()
			
			{
				this.localIPAddress = "";
				this.m_Filename = "";
				this.m_Data = "";
				this.ASCII = new ASCIIEncoding ();
			}
			
		#endregion
		
		#region Properties
		
			public long AppendFrom
			
			{
				get
				{
					return this.m_AppendFrom;
				}
				set
				{
					if (value < ((long) 0))
					{
						this.m_AppendFrom = 0L;
					}
					else
					{
						this.m_AppendFrom = value;
					}
				}
			}
			
			
			public string Data
			
			{
				get
				{
					return this.m_Data;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_Data = value;
					}
				}
			}
			
			
			public bool DownloadToFile
			
			{
				get
				{
					return this.m_DownloadToFile;
				}
				set
				{
					this.m_DownloadToFile = value;
				}
			}
			
			
			public FileModes FileMode
			
			{
				get
				{
					return this.m_FileMode;
				}
				set
				{
					this.m_FileMode = value;
				}
			}
			
			
			public string Filename
			
			{
				get
				{
					return this.m_Filename;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_Filename = value;
					}
				}
			}
			
			
			public IPEndPoint GetLocalEndPoint
			
			{
				get
				{
					return ((IPEndPoint) this.m_DataSocket.LocalEndPoint);
				}
			}
			
			
			public string LocalIPAddress
			
			{
				get
				{
					return this.localIPAddress;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.localIPAddress = value;
					}
				}
			}
			
			
			public int Port
			
			{
				get
				{
					return this.m_Port;
				}
			}
			
			
			public IPEndPoint RemoteEndPoint
			
			{
				get
				{
					return this.m_RemoteEndPoint;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.m_RemoteEndPoint = value;
					}
				}
			}
			
			
			public StreamDirections StreamDirection
			
			{
				get
				{
					return this.m_StreamDirection;
				}
				set
				{
					this.m_StreamDirection = value;
				}
			}
			
			
			public long TransferredBytes
			
			{
				get
				{
					return this.m_TransferredBytes;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void Close ()
			
			{
				try
				{
					this.m_DataSocket.Shutdown (SocketShutdown.Both);
				}
				catch
				{
				}
				this.m_DataSocket.Close ();
				try
				{
					if (this.m_FileStream != null)
					{
						this.m_FileStream.Close ();
					}
				}
				catch
				{
				}
			}
			
			public void Connect ()
			
			{
				IPAddress iPAddress1;
				IPEndPoint iPEndPoint1;
				this.m_TransferredBytes = 0L;
				this.m_Passive = true;
				this.CreateDataFile ();
				try
				{
					this.m_DataSocket = new Socket (AddressFamily.Unspecified, SocketType.Stream, ProtocolType.Tcp);
					iPAddress1 = IPAddress.Parse (this.LocalIPAddress);
					if ((iPAddress1.ToString () == "0.0.0.0") || (iPAddress1.ToString () == ""))
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, 0);
					}
					else
					{
						iPEndPoint1 = new IPEndPoint (iPAddress1, 0);
					}
					this.m_DataSocket.Bind (((EndPoint) iPEndPoint1));
					this.m_DataSocket.Connect (((EndPoint) this.RemoteEndPoint));
				}
				catch
				{
					throw new SocketException ();
				}
			}
			
			public void CreateDataFile ()
			
			{
				switch (this.m_Filename)
				{
					case "":
					
					{
							this.m_DownloadToFile = false;
							return;
					}
					default:
					
					{
							if (this.m_DownloadToFile)
							{
								try
								{
									if (this.m_StreamDirection == StreamDirections.Download)
									{
										this.m_FileStream = new FileStream (this.m_Filename, System.IO.FileMode.OpenOrCreate);
									}
									else
									{
										this.m_FileStream = new FileStream (this.m_Filename, System.IO.FileMode.Open);
									}
									if ((this.m_FileMode == FileModes.Append) && (this.m_AppendFrom > ((long) 0)))
									{
										long int64_1 = this.m_FileStream.Seek (this.m_AppendFrom, SeekOrigin.Begin);
										this.m_TransferredBytes = this.m_FileStream.Position;
									}
								}
								catch
								{
									throw new IOException ();
								}
							}
							return;
					}
				}
			}
			
			public void Listen ()
			
			{
				IPAddress iPAddress1;
				IPEndPoint iPEndPoint1;
				this.m_TransferredBytes = 0L;
				this.m_Passive = false;
				this.CreateDataFile ();
				try
				{
					this.m_DataSocket = new Socket (AddressFamily.Unspecified, SocketType.Stream, ProtocolType.Tcp);
					iPAddress1 = IPAddress.Parse (this.LocalIPAddress);
					if ((iPAddress1.ToString () == "0.0.0.0") || (iPAddress1.ToString () == ""))
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, 0);
					}
					else
					{
						iPEndPoint1 = new IPEndPoint (iPAddress1, 0);
					}
					this.m_DataSocket.Bind (((EndPoint) iPEndPoint1));
					this.m_Port = ((IPEndPoint) this.m_DataSocket.LocalEndPoint).Port;
					this.m_DataSocket.Listen (0);
				}
				catch
				{
					throw new SocketException ();
				}
			}
			
			protected virtual void OnDataReceived (int ByteLen)
			
			{
				if (this.DataReceived != null)
				{
					this.DataReceived (ByteLen);
				}
			}
			
			protected virtual void OnDataSent (int ByteLen)
			
			{
				if (this.DataSent != null)
				{
					this.DataSent (ByteLen);
				}
			}
			
			public void ReceiveFromSocket ()
			
			{
				Socket socket1;
				int i1;
				byte[] byteArray1;
				IOException iOException1;
				try
				{
					if (this.m_DataSocket == null)
					{
						throw new SocketException ();
					}
					else if (this.m_Passive)
					{
						socket1 = this.m_DataSocket;
					}
					else
					{
						socket1 = this.m_DataSocket.Accept ();
					}
				}
				catch
				{
					throw new SocketException ();
				}
				try
				{
					try
					{
						byteArray1 = new byte[1024];
						
					L_003F:
						
						{
						}
						i1 = socket1.Receive (byteArray1);
						if (i1 > 0)
						{
							if (this.m_DownloadToFile)
							{
								this.m_FileStream.Write (byteArray1, 0, i1);
							}
							else
							{
								this.m_Data = (this.m_Data + this.ASCII.GetString (byteArray1, 0, i1));
							}
							this.m_TransferredBytes += ((long) i1);
							this.OnDataReceived (i1);
						}
						if (i1 != 0)
						{
							goto L_003F;
						}
					}
					catch (IOException iOException2)
					{
						iOException1 = iOException2;
						throw iOException1;
					}
					catch
					{
						throw new SocketException ();
					}
				}
				finally
				{
					try
					{
						socket1.Shutdown (SocketShutdown.Both);
					}
					catch
					{
					}
					socket1.Close ();
				}
			}
			
			public void SendToSocket ()
			
			{
				Socket socket1;
				int i1;
				byte[] byteArray1;
				byte[] byteArray2;
				IOException iOException1;
				try
				{
					if (this.m_DataSocket == null)
					{
						throw new SocketException ();
					}
					else if (this.m_Passive)
					{
						socket1 = this.m_DataSocket;
					}
					else
					{
						socket1 = this.m_DataSocket.Accept ();
					}
				}
				catch
				{
					throw new SocketException ();
				}
				try
				{
					try
					{
						byteArray1 = new byte[1024];
						
					L_003F:
						
						{
						}
						if (this.m_DownloadToFile)
						{
							long int64_1 = this.m_FileStream.Seek (this.m_TransferredBytes, SeekOrigin.Begin);
							i1 = this.m_FileStream.Read (byteArray1, 0, 1024);
						}
						else
						{
							if ((this.m_TransferredBytes + ((long) 1024)) < ((long) this.m_Data.Length))
							{
								byteArray2 = this.ASCII.GetBytes (this.m_Data.Substring (((int) this.m_TransferredBytes), 1024));
							}
							else
							{
								byteArray2 = this.ASCII.GetBytes (this.m_Data.Substring (((int) this.m_TransferredBytes)));
							}
							i1 = byteArray2.Length;
							if (byteArray2 != null)
							{
								Array.Copy (((Array) byteArray2), ((Array) byteArray1), i1);
							}
						}
						i1 = socket1.Send (byteArray1, i1, SocketFlags.None);
						this.m_TransferredBytes += ((long) i1);
						this.OnDataSent (i1);
						if (i1 != 0)
						{
							goto L_003F;
						}
					}
					catch (IOException iOException2)
					{
						iOException1 = iOException2;
						throw iOException1;
					}
					catch
					{
						throw new SocketException ();
					}
				}
				finally
				{
					try
					{
						socket1.Shutdown (SocketShutdown.Both);
					}
					catch
					{
					}
					socket1.Close ();
				}
			}
			
		#endregion
	}
	
}

