//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:22:12
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.FTP

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Text;
			
		#endregion
		
	public class FtpClient
	
	{
		
		#region Fields
			private static Encoding ASCII;
			private bool binMode;
			private byte[] buffer;
			private static int BUFFER_SIZE;
			private int bytes;
			private Socket clientSocket;
			private bool loggedin;
			private string message;
			private string password;
			private int port;
			private string remotePath;
			private string result;
			private int resultCode;
			private string server;
			private int timeoutSeconds;
			private string username;
			private bool verboseDebugging;
		#endregion
		
		#region Nested Types
		
			private delegate void ChangeDirCallback (string dirName);
			
			private delegate void CloseCallback ();
			
			private delegate void DeleteFileCallback (string fileName);
			
			private delegate void DownloadCallback (string remFileName);
			
			private delegate void DownloadFileNameFileNameCallback (string remFileName, string locFileName);
			
			private delegate void DownloadFileNameFileNameResumeCallback (string remFileName, string locFileName, bool resume);
			
			private delegate void DownloadFileNameResumeCallback (string remFileName, bool resume);
			
			public class FtpException : Exception
			
			{
				
				#region Constructors
				
					public FtpException (string message)
						 : base (message)
					
					{
					}
					
					
					public FtpException (string message, Exception innerException)
						 : base (message, innerException)
					
					{
					}
					
				#endregion
			}
			
			
			private delegate string[] GetFileListCallback ();
			
			private delegate string[] GetFileListMaskCallback (string mask);
			
			private delegate long GetFileSizeCallback (string fileName);
			
			private delegate void LoginCallback ();
			
			private delegate void MakeDirCallback (string dirName);
			
			private delegate void RemoveDirCallback (string dirName);
			
			private delegate void RenameFileCallback (string oldFileName, string newFileName, bool overwrite);
			
			private delegate void UploadCallback (string fileName);
			
			private delegate void UploadDirectoryCallback (string path, bool recurse);
			
			private delegate void UploadDirectoryPathRecurseMaskCallback (string path, bool recurse, string mask);
			
			private delegate void UploadFileNameResumeCallback (string fileName, bool resume);
		#endregion
		
		#region Constructors
		
			public FtpClient ()
			
			{
				this.server = "localhost";
				this.remotePath = ".";
				this.username = "anonymous";
				this.password = "anonymous@anonymous.net";
				this.port = 21;
				this.buffer = new byte[FtpClient.BUFFER_SIZE];
				this.timeoutSeconds = 10;
			}
			
			
			public FtpClient (string server, string username, string password)
			
			{
				this.server = "localhost";
				this.remotePath = ".";
				this.username = "anonymous";
				this.password = "anonymous@anonymous.net";
				this.port = 21;
				this.buffer = new byte[FtpClient.BUFFER_SIZE];
				this.timeoutSeconds = 10;
				this.server = server;
				this.username = username;
				this.password = password;
			}
			
			
			public FtpClient (string server, string username, string password, int timeoutSeconds, int port)
			
			{
				this.server = "localhost";
				this.remotePath = ".";
				this.username = "anonymous";
				this.password = "anonymous@anonymous.net";
				this.port = 21;
				this.buffer = new byte[FtpClient.BUFFER_SIZE];
				this.timeoutSeconds = 10;
				this.server = server;
				this.username = username;
				this.password = password;
				this.timeoutSeconds = timeoutSeconds;
				this.port = port;
			}
			
			
			static FtpClient ()
			
			{
				FtpClient.BUFFER_SIZE = 512;
				FtpClient.ASCII = Encoding.ASCII;
			}
			
		#endregion
		
		#region Properties
		
			public bool BinaryMode
			
			{
				get
				{
					return this.binMode;
				}
				set
				{
					if (this.binMode == value)
					{
					}
					else
					{
						if (value)
						{
							this.sendCommand ("TYPE I");
						}
						else
						{
							this.sendCommand ("TYPE A");
						}
						if (this.resultCode != 200)
						{
							throw new FtpException (this.result.Substring (4));
						}
					}
				}
			}
			
			
			public string Password
			
			{
				get
				{
					return this.password;
				}
				set
				{
					this.password = value;
				}
			}
			
			
			public int Port
			
			{
				get
				{
					return this.port;
				}
				set
				{
					this.port = value;
				}
			}
			
			
			public string RemotePath
			
			{
				get
				{
					return this.remotePath;
				}
				set
				{
					this.remotePath = value;
				}
			}
			
			
			public int RemotePort
			
			{
				get
				{
					return this.port;
				}
				set
				{
					this.port = value;
				}
			}
			
			
			public string Server
			
			{
				get
				{
					return this.server;
				}
				set
				{
					this.server = value;
				}
			}
			
			
			public int Timeout
			
			{
				get
				{
					return this.timeoutSeconds;
				}
				set
				{
					this.timeoutSeconds = value;
				}
			}
			
			
			public string Username
			
			{
				get
				{
					return this.username;
				}
				set
				{
					this.username = value;
				}
			}
			
			
			public bool VerboseDebugging
			
			{
				get
				{
					return this.verboseDebugging;
				}
				set
				{
					this.verboseDebugging = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public IAsyncResult BeginChangeDir (string dirName, AsyncCallback callback)
			
			{
				ChangeDirCallback changeDirCallback1 = new ChangeDirCallback (this.ChangeDir);
				return changeDirCallback1.BeginInvoke (dirName, callback, null);
			}
			
			public IAsyncResult BeginClose (AsyncCallback callback)
			
			{
				CloseCallback closeCallback1 = new CloseCallback (this.Close);
				return closeCallback1.BeginInvoke (callback, null);
			}
			
			public IAsyncResult BeginDeleteFile (string fileName, AsyncCallback callback)
			
			{
				DeleteFileCallback deleteFileCallback1 = new DeleteFileCallback (this.DeleteFile);
				return deleteFileCallback1.BeginInvoke (fileName, callback, null);
			}
			
			public IAsyncResult BeginDownload (string remFileName, string locFileName, bool resume, AsyncCallback callback)
			
			{
				DownloadFileNameFileNameResumeCallback downloadFileNameFileNameResumeCallback1 = new DownloadFileNameFileNameResumeCallback (this.Download);
				return downloadFileNameFileNameResumeCallback1.BeginInvoke (remFileName, locFileName, resume, callback, null);
			}
			
			public IAsyncResult BeginDownload (string remFileName, bool resume, AsyncCallback callback)
			
			{
				DownloadFileNameResumeCallback downloadFileNameResumeCallback1 = new DownloadFileNameResumeCallback (this.Download);
				return downloadFileNameResumeCallback1.BeginInvoke (remFileName, resume, callback, null);
			}
			
			public IAsyncResult BeginDownload (string remFileName, AsyncCallback callback)
			
			{
				DownloadCallback downloadCallback1 = new DownloadCallback (this.Download);
				return downloadCallback1.BeginInvoke (remFileName, callback, null);
			}
			
			public IAsyncResult BeginDownload (string remFileName, string locFileName, AsyncCallback callback)
			
			{
				DownloadFileNameFileNameCallback downloadFileNameFileNameCallback1 = new DownloadFileNameFileNameCallback (this.Download);
				return downloadFileNameFileNameCallback1.BeginInvoke (remFileName, locFileName, callback, null);
			}
			
			public IAsyncResult BeginGetFileList (string mask, AsyncCallback callback)
			
			{
				GetFileListMaskCallback getFileListMaskCallback1 = new GetFileListMaskCallback (this.GetFileList);
				return getFileListMaskCallback1.BeginInvoke (mask, callback, null);
			}
			
			public IAsyncResult BeginGetFileList (AsyncCallback callback)
			
			{
				GetFileListCallback getFileListCallback1 = new GetFileListCallback (this.GetFileList);
				return getFileListCallback1.BeginInvoke (callback, null);
			}
			
			public IAsyncResult BeginGetFileSize (string fileName, AsyncCallback callback)
			
			{
				GetFileSizeCallback getFileSizeCallback1 = new GetFileSizeCallback (this.GetFileSize);
				return getFileSizeCallback1.BeginInvoke (fileName, callback, null);
			}
			
			public IAsyncResult BeginLogin (AsyncCallback callback)
			
			{
				LoginCallback loginCallback1 = new LoginCallback (this.Login);
				return loginCallback1.BeginInvoke (callback, null);
			}
			
			public IAsyncResult BeginMakeDir (string dirName, AsyncCallback callback)
			
			{
				MakeDirCallback makeDirCallback1 = new MakeDirCallback (this.MakeDir);
				return makeDirCallback1.BeginInvoke (dirName, callback, null);
			}
			
			public IAsyncResult BeginRemoveDir (string dirName, AsyncCallback callback)
			
			{
				RemoveDirCallback removeDirCallback1 = new RemoveDirCallback (this.RemoveDir);
				return removeDirCallback1.BeginInvoke (dirName, callback, null);
			}
			
			public IAsyncResult BeginRenameFile (string oldFileName, string newFileName, bool overwrite, AsyncCallback callback)
			
			{
				RenameFileCallback renameFileCallback1 = new RenameFileCallback (this.RenameFile);
				return renameFileCallback1.BeginInvoke (oldFileName, newFileName, overwrite, callback, null);
			}
			
			public IAsyncResult BeginUpload (string fileName, bool resume, AsyncCallback callback)
			
			{
				UploadFileNameResumeCallback uploadFileNameResumeCallback1 = new UploadFileNameResumeCallback (this.Upload);
				return uploadFileNameResumeCallback1.BeginInvoke (fileName, resume, callback, null);
			}
			
			public IAsyncResult BeginUpload (string fileName, AsyncCallback callback)
			
			{
				UploadCallback uploadCallback1 = new UploadCallback (this.Upload);
				return uploadCallback1.BeginInvoke (fileName, callback, null);
			}
			
			public IAsyncResult BeginUploadDirectory (string path, bool recurse, AsyncCallback callback)
			
			{
				UploadDirectoryCallback uploadDirectoryCallback1 = new UploadDirectoryCallback (this.UploadDirectory);
				return uploadDirectoryCallback1.BeginInvoke (path, recurse, callback, null);
			}
			
			public IAsyncResult BeginUploadDirectory (string path, bool recurse, string mask, AsyncCallback callback)
			
			{
				UploadDirectoryPathRecurseMaskCallback uploadDirectoryPathRecurseMaskCallback1 = new UploadDirectoryPathRecurseMaskCallback (this.UploadDirectory);
				return uploadDirectoryPathRecurseMaskCallback1.BeginInvoke (path, recurse, mask, callback, null);
			}
			
			public void ChangeDir (string dirName)
			
			{
				if ((dirName == null) || (dirName.Equals (".") || (dirName.Length == 0)))
				{
					return;
				}
				if (! this.loggedin)
				{
					this.Login ();
				}
				this.sendCommand (("CWD " + dirName));
				if (this.resultCode != 250)
				{
					throw new FtpException (this.result.Substring (4));
				}
				this.sendCommand ("PWD");
				if (this.resultCode != 257)
				{
					throw new FtpException (this.result.Substring (4));
				}
				char[] charArray1 = new char[] { '\"' };
				this.remotePath = this.message.Split (charArray1)[1];
			}
			
			private void cleanup ()
			
			{
				if (this.clientSocket != null)
				{
					this.clientSocket.Close ();
					this.clientSocket = ((Socket) null);
				}
				this.loggedin = false;
			}
			
			public void Close ()
			
			{
				if (this.clientSocket != null)
				{
					this.sendCommand ("QUIT");
				}
				this.cleanup ();
			}
			
			private Socket createDataSocket ()
			
			{
				char char1;
				Exception exception1;
				string string3;
				int i6;
				Socket socket1;
				IPEndPoint iPEndPoint1;
				Exception exception2;
				object[] objectArray1;
				this.sendCommand ("PASV");
				if (this.resultCode != 227)
				{
					throw new FtpException (this.result.Substring (4));
				}
				int i1 = this.result.IndexOf ('\u0028');
				int i2 = this.result.IndexOf ('\u0029');
				string string1 = this.result.Substring (((int) (i1 + 1)), ((int) ((i2 - i1) - 1)));
				int[] int32Array1 = new int[6];
				int i3 = string1.Length;
				int i4 = 0;
				string string2 = "";
				for (int i5 = 0; true; i5++)
				{
					if ((i5 >= i3) || (i4 > 6))
					{
						objectArray1 = new object[] { int32Array1[0], ".", int32Array1[1], ".", int32Array1[2], ".", int32Array1[3] };
						string3 = string.Concat (objectArray1);
						i6 = ((int32Array1[4] << 8) + int32Array1[5]);
						socket1 = ((Socket) null);
						iPEndPoint1 = ((IPEndPoint) null);
						try
						{
							socket1 = new Socket (AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
							iPEndPoint1 = new IPEndPoint (Dns.Resolve (string3).AddressList[0], i6);
							socket1.Connect (((EndPoint) iPEndPoint1));
						}
						catch (Exception exception4)
						{
							exception2 = exception4;
							if ((socket1 != null) && socket1.Connected)
							{
								socket1.Close ();
							}
							throw new FtpException ("Can\'t connect to remote server", exception2);
						}
						return socket1;
					}
					char1 = char.Parse (string1.Substring (i5, 1));
					if (char.IsDigit (char1))
					{
						string2 = (string2 + char1.ToString ());
					}
					else if (char1 != '\u002C')
					{
						throw new FtpException (("Malformed PASV result: " + this.result));
					}
					if ((char1 == '\u002C') || ((i5 + 1) == i3))
					{
						try
						{
							int32Array1[i4++] = int.Parse (string2);
							string2 = "";
						}
						catch (Exception exception3)
						{
							exception1 = exception3;
							throw new FtpException (("Malformed PASV result (not supported?): " + this.result), exception1);
						}
					}
				}
			}
			
			public void DeleteFile (string fileName)
			
			{
				if (! this.loggedin)
				{
					this.Login ();
				}
				this.sendCommand (("DELE " + fileName));
				if (this.resultCode != 250)
				{
					throw new FtpException (this.result.Substring (4));
				}
			}
			
			public void Download (string remFileName, string locFileName, bool resume)
			
			{
				FileStream fileStream1;
				if (! this.loggedin)
				{
					this.Login ();
				}
				this.BinaryMode = true;
				if (locFileName.Equals (""))
				{
					locFileName = remFileName;
				}
				if (! File.Exists (locFileName))
				{
					fileStream1 = File.Create (locFileName);
				}
				else
				{
					fileStream1 = new FileStream (locFileName, FileMode.Open);
				}
				Socket socket1 = this.createDataSocket ();
				long int64_1 = 0L;
				if (resume)
				{
					int64_1 = fileStream1.Length;
					if (int64_1 > ((long) 0))
					{
						this.sendCommand (("REST " + int64_1.ToString ()));
						if (this.resultCode == 350)
						{
							long int64_2 = fileStream1.Seek (int64_1, SeekOrigin.Begin);
						}
						else
						{
							int64_1 = 0L;
						}
					}
				}
				this.sendCommand (("RETR " + remFileName));
				if ((this.resultCode != 150) && (this.resultCode != 125))
				{
					throw new FtpException (this.result.Substring (4));
				}
				DateTime dateTime2 = DateTime.Now;
				DateTime dateTime1 = dateTime2.AddSeconds (((double) this.timeoutSeconds));
				while (dateTime1 > DateTime.Now)
				{
					this.bytes = socket1.Receive (this.buffer, this.buffer.Length, SocketFlags.None);
					fileStream1.Write (this.buffer, 0, this.bytes);
					if (this.bytes <= 0)
					{
						break;
					}
				}
				fileStream1.Close ();
				if (socket1.Connected)
				{
					socket1.Close ();
				}
				this.readResponse ();
				if ((this.resultCode != 226) && (this.resultCode != 250))
				{
					throw new FtpException (this.result.Substring (4));
				}
			}
			
			public void Download (string remFileName, bool resume)
			
			{
				this.Download (remFileName, "", resume);
			}
			
			public void Download (string remFileName, string locFileName)
			
			{
				this.Download (remFileName, locFileName, false);
			}
			
			public void Download (string remFileName)
			
			{
				this.Download (remFileName, "", false);
			}
			
			~FtpClient ()
			
			{
				this.cleanup ();
			}
			
			public string[] GetFileList ()
			
			{
				return this.GetFileList ("*.*");
			}
			
			public string[] GetFileList (string mask)
			
			{
				int i1;
				if (! this.loggedin)
				{
					this.Login ();
				}
				Socket socket1 = this.createDataSocket ();
				this.sendCommand (("NLST " + mask));
				if ((this.resultCode != 150) && (this.resultCode != 125))
				{
					throw new FtpException (this.result.Substring (4));
				}
				this.message = "";
				DateTime dateTime2 = DateTime.Now;
				DateTime dateTime1 = dateTime2.AddSeconds (((double) this.timeoutSeconds));
				while (dateTime1 > DateTime.Now)
				{
					i1 = socket1.Receive (this.buffer, this.buffer.Length, SocketFlags.None);
					this.message = (this.message + FtpClient.ASCII.GetString (this.buffer, 0, i1));
					if (i1 < this.buffer.Length)
					{
						break;
					}
				}
				char[] charArray1 = new char[] { '\n' };
				string[] stringArray1 = this.message.Replace ("\r", "").Split (charArray1);
				socket1.Close ();
				if (this.message.IndexOf ("No such file or directory") != -1)
				{
					stringArray1 = new string[0];
				}
				this.readResponse ();
				if (this.resultCode == 226)
				{
					return stringArray1;
				}
				else
				{
					return new string[0];
				}
			}
			
			public long GetFileSize (string fileName)
			
			{
				if (! this.loggedin)
				{
					this.Login ();
				}
				this.sendCommand (("SIZE " + fileName));
				if (this.resultCode == 213)
				{
					return long.Parse (this.result.Substring (4));
				}
				else
				{
					throw new FtpException (this.result.Substring (4));
				}
			}
			
			public void Login ()
			
			{
				Exception exception1;
				if (this.loggedin)
				{
					this.Close ();
				}
				IPAddress iPAddress1 = ((IPAddress) null);
				IPEndPoint iPEndPoint1 = ((IPEndPoint) null);
				try
				{
					this.clientSocket = new Socket (AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
					iPAddress1 = Dns.Resolve (this.server).AddressList[0];
					iPEndPoint1 = new IPEndPoint (iPAddress1, this.port);
					this.clientSocket.Connect (((EndPoint) iPEndPoint1));
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					if ((this.clientSocket != null) && this.clientSocket.Connected)
					{
						this.clientSocket.Close ();
					}
					throw new FtpException ("Couldn\'t connect to remote server", exception1);
				}
				this.readResponse ();
				if (this.resultCode != 220)
				{
					this.Close ();
					throw new FtpException (this.result.Substring (4));
				}
				else
				{
					this.sendCommand (("USER " + this.username));
					if ((this.resultCode != 331) && (this.resultCode != 230))
					{
						this.cleanup ();
						throw new FtpException (this.result.Substring (4));
					}
					else
					{
						if (this.resultCode != 230)
						{
							this.sendCommand (("PASS " + this.password));
							if ((this.resultCode != 230) && (this.resultCode != 202))
							{
								this.cleanup ();
								throw new FtpException (this.result.Substring (4));
							}
						}
						this.loggedin = true;
						this.ChangeDir (this.remotePath);
					}
				}
			}
			
			public void MakeDir (string dirName)
			
			{
				if (! this.loggedin)
				{
					this.Login ();
				}
				this.sendCommand (("MKD " + dirName));
				if ((this.resultCode != 250) && (this.resultCode != 257))
				{
					throw new FtpException (this.result.Substring (4));
				}
			}
			
			private string readLine ()
			
			{
				string[] stringArray1;
				int i1;
				char[] charArray1;
				while (true)
				{
					this.bytes = this.clientSocket.Receive (this.buffer, this.buffer.Length, SocketFlags.None);
					this.message = (this.message + FtpClient.ASCII.GetString (this.buffer, 0, this.bytes));
					if (this.bytes < this.buffer.Length)
					{
						charArray1 = new char[] { '\n' };
						stringArray1 = this.message.Split (charArray1);
						if (this.message.Length > 2)
						{
							this.message = stringArray1[(stringArray1.Length - 2)];
						}
						else
						{
							this.message = stringArray1[0];
						}
						if ((this.message.Length > 4) && (! this.message.Substring (3, 1).Equals (" ")))
						{
							return this.readLine ();
						}
						else
						{
							if (this.verboseDebugging)
							{
								for (i1 = 0; (i1 < (stringArray1.Length - 1)); i1++)
								{
								}
							}
							return this.message;
						}
					}
				}
			}
			
			private void readResponse ()
			
			{
				this.message = "";
				this.result = this.readLine ();
				if (this.result.Length > 3)
				{
					this.resultCode = int.Parse (this.result.Substring (0, 3));
				}
				else
				{
					this.result = ((string) null);
				}
			}
			
			public void RemoveDir (string dirName)
			
			{
				if (! this.loggedin)
				{
					this.Login ();
				}
				this.sendCommand (("RMD " + dirName));
				if (this.resultCode != 250)
				{
					throw new FtpException (this.result.Substring (4));
				}
			}
			
			public void RenameFile (string oldFileName, string newFileName, bool overwrite)
			
			{
				if (! this.loggedin)
				{
					this.Login ();
				}
				this.sendCommand (("RNFR " + oldFileName));
				if (this.resultCode != 350)
				{
					throw new FtpException (this.result.Substring (4));
				}
				else if ((! overwrite) && (this.GetFileList (newFileName).Length > 0))
				{
					throw new FtpException ("File already exists");
				}
				else
				{
					this.sendCommand (("RNTO " + newFileName));
					if (this.resultCode != 250)
					{
						throw new FtpException (this.result.Substring (4));
					}
				}
			}
			
			private void sendCommand (string command)
			
			{
				byte[] byteArray1 = Encoding.ASCII.GetBytes ((command + "\r\n").ToCharArray ());
				int i1 = this.clientSocket.Send (byteArray1, byteArray1.Length, SocketFlags.None);
				this.readResponse ();
			}
			
			public void Upload (string fileName)
			
			{
				this.Upload (fileName, false);
			}
			
			public void Upload (string fileName, bool resume)
			
			{
				int i1;
				if (! this.loggedin)
				{
					this.Login ();
				}
				long int64_1 = 0L;
				if (resume)
				{
					try
					{
						this.BinaryMode = true;
						int64_1 = this.GetFileSize (Path.GetFileName (fileName));
					}
					catch (Exception)
					{
						int64_1 = 0L;
					}
				}
				FileStream fileStream1 = new FileStream (fileName, FileMode.Open);
				if (resume && (fileStream1.Length < int64_1))
				{
					int64_1 = 0L;
				}
				else if (resume && (fileStream1.Length == int64_1))
				{
					fileStream1.Close ();
					return;
				}
				Socket socket1 = this.createDataSocket ();
				if (int64_1 > ((long) 0))
				{
					this.sendCommand (("REST " + int64_1.ToString ()));
					if (this.resultCode != 350)
					{
						int64_1 = 0L;
					}
				}
				this.sendCommand (("STOR " + Path.GetFileName (fileName)));
				if ((this.resultCode != 125) && (this.resultCode != 150))
				{
					throw new FtpException (this.result.Substring (4));
				}
				else
				{
					if (int64_1 != ((long) 0))
					{
						long int64_2 = fileStream1.Seek (int64_1, SeekOrigin.Begin);
					}
					while (true)
					{
						this.bytes = (i1 = fileStream1.Read (this.buffer, 0, this.buffer.Length));
						if (i1 <= 0)
						{
							fileStream1.Close ();
							if (socket1.Connected)
							{
								socket1.Close ();
							}
							this.readResponse ();
							if ((this.resultCode != 226) && (this.resultCode != 250))
							{
								throw new FtpException (this.result.Substring (4));
							}
							else
							{
								return;
							}
						}
						int i2 = socket1.Send (this.buffer, this.bytes, SocketFlags.None);
					}
				}
			}
			
			public void UploadDirectory (string path, bool recurse)
			
			{
				this.UploadDirectory (path, recurse, "*.*");
			}
			
			public void UploadDirectory (string path, bool recurse, string mask)
			
			{
				char[] charArray1 = new char[] { '\\' };
				string[] stringArray1 = path.Replace ("/", "\\").Split (charArray1);
				string string1 = stringArray1[(stringArray1.Length - 1)];
				if (this.GetFileList (string1).Length < 1)
				{
					this.MakeDir (string1);
				}
				this.ChangeDir (string1);
				foreach (string string2 in Directory.GetFiles (path, mask))
				{
					this.Upload (string2, true);
				}
				if (recurse)
				{
					foreach (string string3 in Directory.GetDirectories (path))
					{
						this.UploadDirectory (string3, recurse, mask);
					}
				}
				this.ChangeDir ("..");
			}
			
		#endregion
	}
	
}

