//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:23:08
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECBroadcast

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using System.Collections;
			using System.Net;
			using System;
			using System.Runtime.InteropServices;
			using System.Threading;
			
		#endregion
		
	[ProgIdAttribute("LEC.Broadcast")]
	[ClassInterfaceAttribute(ClassInterfaceType.None)]
	[GuidAttribute("123D4A73-5433-4087-BD84-31C7A71C68C0")]
	public sealed class Broadcast : ILecBroadcast
	
	{
		
		#region Fields
			private SharedArrayList broadcastRecords;
			public const uint Error_Exception = 23;
			public const uint Error_IllegalClientId = 4;
			public const uint Error_InvalidPersistState = 5;
			public const uint Error_LicenseAccessDenied = 22;
			public const uint Error_LicenseUnavailable = 21;
			public const uint Error_NotConnected = 3;
			public const uint Error_ServerNameNotFound = 8;
			private static readonly Broadcast instance;
			public event AdvertiseEventHandler OnAdvertiseEvent;
			public const uint Success = uint.MinValue;
		#endregion
		
		#region Constructors
		
			static Broadcast ()
			
			{
				Broadcast.instance = new Broadcast ();
			}
			
			
			public Broadcast ()
			
			{
				this.broadcastRecords = new SharedArrayList ();
			}
			
		#endregion
		
		#region Properties
		
			public static Broadcast Instance
			
			{
				get
				{
					return Broadcast.instance;
				}
			}
			
		#endregion
		
		#region Methods
		
			public uint clientAttachBroadcast (string multicastAddress, string localAddress, int localPortNumber, ref int piClientId)
			
			{
				int i1;
				LECReceiveThread lECReceiveThread1;
				uint uInt32_1;
				object object1;
				object object2;
				try
				{
					piClientId = SharedArrayList.CalcId ((multicastAddress + localPortNumber.ToString ()));
					i1 = -1;
					object1 = this.broadcastRecords.SyncRoot;
					lock (object1)
					{
						i1 = this.broadcastRecords.Add (piClientId);
					}
					if (i1 != -1)
					{
						return uint.MinValue;
					}
					IPAddress iPAddress1 = IPAddress.Parse (multicastAddress);
					lECReceiveThread1 = new LECReceiveThread (IPAddress.Parse (multicastAddress), IPAddress.Parse (localAddress), localPortNumber);
					lECReceiveThread1.OnAdvertiseEvent += new AdvertiseEventHandler (this.oUDPNewRec_OnAdvertiseEvent);
					if (lECReceiveThread1.StartThread ())
					{
						object2 = this.broadcastRecords.SyncRoot;
						lock (object2)
						{
							int i2 = this.broadcastRecords.Add (lECReceiveThread1, piClientId);
							goto L_00B2;
						}
					}
					piClientId = -1;
					return 3;
					
				L_00B2:
					
					{
					}
					uInt32_1 = uint.MinValue;
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint clientDetachBroadcast (int piClientId)
			
			{
				int i1;
				LECReceiveThread lECReceiveThread1;
				uint uInt32_1;
				object object1;
				try
				{
					object1 = this.broadcastRecords.SyncRoot;
					lock (object1)
					{
						i1 = this.broadcastRecords.IndexOf (piClientId);
						if (i1 != -1)
						{
							if (this.broadcastRecords.ShareCountAt (i1) < 1)
							{
								lECReceiveThread1 = ((LECReceiveThread) this.broadcastRecords[i1]);
								if (lECReceiveThread1.IsThreadRunning)
								{
									bool b1 = lECReceiveThread1.StopThread ();
								}
							}
							this.broadcastRecords.RemoveAt (i1);
						}
					}
					uInt32_1 = uint.MinValue;
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint getBroadcastData (int piClientId, string pstrFriendlyName, int piDataType, out string piData)
			
			{
				int i1;
				LECReceiveThread lECReceiveThread1;
				uint uInt32_1;
				object object1;
				piData = "";
				try
				{
					object1 = this.broadcastRecords.SyncRoot;
					lock (object1)
					{
						i1 = this.broadcastRecords.IndexOf (piClientId);
						if (i1 != -1)
						{
							lECReceiveThread1 = ((LECReceiveThread) this.broadcastRecords[i1]);
							if (! lECReceiveThread1.GetData (pstrFriendlyName, piDataType, out piData))
							{
								piData = "";
								return 8;
							}
						}
						else
						{
							return 4;
						}
					}
					switch (piData)
					{
						case "":
						
						{
								return 8;
						}
						default:
						
						{
								uInt32_1 = uint.MinValue;
								break;
						}
					}
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint getBroadcastData (int piClientId, string pstrFriendlyName, int piDataType, out BaseConfig poData)
			
			{
				int i1;
				LECReceiveThread lECReceiveThread1;
				uint uInt32_1;
				object object1;
				poData = ((BaseConfig) null);
				try
				{
					if (pstrFriendlyName.Length == 0)
					{
						return 8;
					}
					else
					{
						object1 = this.broadcastRecords.SyncRoot;
						lock (object1)
						{
							i1 = this.broadcastRecords.IndexOf (piClientId);
							if (i1 != -1)
							{
								lECReceiveThread1 = ((LECReceiveThread) this.broadcastRecords[i1]);
								if (lECReceiveThread1.GetData (pstrFriendlyName, piDataType, out poData))
								{
								}
							}
							else
							{
								return 4;
							}
						}
						if (poData == null)
						{
							return 8;
						}
						else
						{
							uInt32_1 = uint.MinValue;
						}
					}
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint getLECServerCount (int piClientId, out int piServerCount)
			
			{
				int i1;
				LECReceiveThread lECReceiveThread1;
				uint uInt32_1;
				object object1;
				piServerCount = 0;
				try
				{
					object1 = this.broadcastRecords.SyncRoot;
					lock (object1)
					{
						i1 = this.broadcastRecords.IndexOf (piClientId);
						if (i1 != -1)
						{
							lECReceiveThread1 = ((LECReceiveThread) this.broadcastRecords[i1]);
							piServerCount = lECReceiveThread1.ServerListCount;
							return uint.MinValue;
						}
					}
					uInt32_1 = 4;
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint getLECServerList (int piClientId, out int piServerCount, out ArrayList plstFriendlyName)
			
			{
				int i1;
				LECReceiveThread lECReceiveThread1;
				object object1;
				piServerCount = 0;
				plstFriendlyName = new ArrayList ();
				try
				{
					object1 = this.broadcastRecords.SyncRoot;
					lock (object1)
					{
						i1 = this.broadcastRecords.IndexOf (piClientId);
						if (i1 != -1)
						{
							lECReceiveThread1 = ((LECReceiveThread) this.broadcastRecords[i1]);
							piServerCount = lECReceiveThread1.ServerListCount;
							plstFriendlyName = lECReceiveThread1.ServerArrayList;
							return uint.MinValue;
						}
					}
					return 3;
				}
				catch (Exception)
				{
				}
				return 23;
			}
			
			public uint getLECServerList (int piClientId, out int piServerCount, out string pstrFriendlyName)
			
			{
				int i1;
				LECReceiveThread lECReceiveThread1;
				uint uInt32_1;
				object object1;
				piServerCount = 0;
				pstrFriendlyName = "";
				try
				{
					object1 = this.broadcastRecords.SyncRoot;
					lock (object1)
					{
						i1 = this.broadcastRecords.IndexOf (piClientId);
						if (i1 != -1)
						{
							lECReceiveThread1 = ((LECReceiveThread) this.broadcastRecords[i1]);
							piServerCount = lECReceiveThread1.ServerListCount;
							pstrFriendlyName = lECReceiveThread1.ServerList;
							return uint.MinValue;
						}
					}
					uInt32_1 = 4;
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			private void oUDPNewRec_OnAdvertiseEvent (object sender, AdvertiseEventArgs e)
			
			{
				if (this.OnAdvertiseEvent != null)
				{
					this.OnAdvertiseEvent (this, e);
				}
			}
			
			public uint updateBroadcastItemInList (int piClientId, string pstrFriendlyName, ConnectionType penumState, bool pbPersistState)
			
			{
				BaseConfig baseConfig1;
				int i1;
				LECReceiveThread lECReceiveThread1;
				IPAddress iPAddress1;
				uint uInt32_1;
				int i2;
				SysInfoData sysInfoData1;
				SysInfoData sysInfoData2;
				object object1;
				ConnectionType connectionType1;
				try
				{
					if (pstrFriendlyName.Length == 0)
					{
						return 8;
					}
					else
					{
						baseConfig1 = ((BaseConfig) null);
						if ((penumState == ConnectionType.Null) && (! pbPersistState))
						{
							return 5;
						}
						else
						{
							object1 = this.broadcastRecords.SyncRoot;
							lock (object1)
							{
								i1 = this.broadcastRecords.IndexOf (piClientId);
								if (i1 != -1)
								{
									lECReceiveThread1 = ((LECReceiveThread) this.broadcastRecords[i1]);
									iPAddress1 = IPAddress.Parse ("0.0.0.0");
									uInt32_1 = 128;
									connectionType1 = penumState;
									switch (connectionType1)
									{
										case ConnectionType.Connected:
										
										{
												uInt32_1 = 1;
												iPAddress1 = IPAddressEx.CurrentAddress;
												break;
										}
										case ConnectionType.ConnectedBusy:
										
										{
												uInt32_1 = 64;
												iPAddress1 = IPAddressEx.CurrentAddress;
												break;
										}
										case ConnectionType.Disconnected:
										
										{
												uInt32_1 = uint.MinValue;
												break;
										}
										case ConnectionType.DisconnectedBusy:
										
										{
												uInt32_1 = 16;
												break;
										}
										case ConnectionType.Lost:
										
										{
												uInt32_1 = 128;
												break;
										}
										case ConnectionType.NotFound:
										
										{
												uInt32_1 = 512;
												break;
										}
									}
									i2 = lECReceiveThread1.GetLocData (pstrFriendlyName, 1, out baseConfig1);
									if (i2 == -1)
									{
										sysInfoData2 = new SysInfoData (pstrFriendlyName);
										sysInfoData2.ConnectedAddress = iPAddress1;
										sysInfoData2.StateCode = uInt32_1;
										sysInfoData2.Address = ((IPAddress) null);
										bool b4 = lECReceiveThread1.AddData (((BaseConfig) sysInfoData2));
									}
									else if (penumState == ConnectionType.Null)
									{
										bool b1 = lECReceiveThread1.SetClientData (i2, "");
										return uint.MinValue;
									}
									else if (pbPersistState)
									{
										bool b2 = lECReceiveThread1.SetClientData (i2, uInt32_1.ToString ());
									}
									else
									{
										sysInfoData1 = (baseConfig1 as SysInfoData);
										sysInfoData1.ConnectedAddress = iPAddress1;
										sysInfoData1.StateCode = uInt32_1;
										bool b3 = lECReceiveThread1.SetData (i2, ((BaseConfig) sysInfoData1));
									}
								}
								else
								{
									return 4;
								}
							}
							return uint.MinValue;
						}
					}
				}
				catch (Exception)
				{
				}
				return 23;
			}
			
		#endregion
	}
	
}

