//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:23:08
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECBroadcast

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Protocol;
			using System;
			using System.Net;
			using System.Runtime.InteropServices;
			using System.Threading;
			
		#endregion
		
	[ComVisibleAttribute(false)]
	internal class DeviceBroadcastPacket
	
	{
		
		#region Fields
			private int expirationTime;
			private int m_dtLastUpdate;
			private IPAddress m_ipServerAddress;
			private BaseConfig m_oServerData;
			private string m_strClientData;
			private uint m_uiContactRetry;
			public event AdvertiseEventHandler OnAdvertiseEvent;
			private Timer validateTimer;
		#endregion
		
		#region Constructors
		
			public DeviceBroadcastPacket ()
			
			{
				this.expirationTime = 8000;
				this.m_strClientData = "";
			}
			
			
			public DeviceBroadcastPacket (IPAddress serverAddress, BaseConfig serverData, int expirationTime)
			
			{
				this.expirationTime = 8000;
				this.m_strClientData = "";
				this.ServerAddress = serverAddress;
				this.ServerData = serverData;
				this.expirationTime = expirationTime;
				TimerCallback timerCallback1 = new TimerCallback (this.ValidateTimeoutCallback);
				this.validateTimer = new Timer (timerCallback1, this, this.ValidateTimeout, this.ValidateTimeout);
			}
			
		#endregion
		
		#region Properties
		
			public string ClientData
			
			{
				get
				{
					return this.m_strClientData;
				}
				set
				{
					this.m_strClientData = value;
				}
			}
			
			
			public uint ContactRetry
			
			{
				get
				{
					return this.m_uiContactRetry;
				}
				set
				{
					this.m_uiContactRetry = value;
				}
			}
			
			
			public int LastUpdate
			
			{
				get
				{
					return this.m_dtLastUpdate;
				}
			}
			
			
			public IPAddress ServerAddress
			
			{
				get
				{
					return this.m_ipServerAddress;
				}
				set
				{
					this.m_ipServerAddress = value;
				}
			}
			
			
			public BaseConfig ServerData
			
			{
				get
				{
					return this.m_oServerData;
				}
				set
				{
					this.m_oServerData = value;
					this.m_dtLastUpdate = Environment.TickCount;
					this.m_uiContactRetry = uint.MinValue;
				}
			}
			
			
			private int ValidateTimeout
			
			{
				get
				{
					return (this.expirationTime + 2000);
				}
			}
			
		#endregion
		
		#region Methods
		
			public Type GetDataType ()
			
			{
				return this.ServerData.GetType ();
			}
			
			public void ValidateTimeoutCallback (object stateInfo)
			
			{
				AdvertiseEventArgs advertiseEventArgs1;
				BaseConfig baseConfig1;
				SysInfoData sysInfoData1;
				BaseConfig baseConfig2;
				StatInfoData statInfoData1;
				if (this.validateTimer != null)
				{
					bool b1 = this.validateTimer.Change (-1, this.ValidateTimeout);
				}
				int i1 = Environment.TickCount;
				if ((i1 - this.LastUpdate) >= this.expirationTime)
				{
					advertiseEventArgs1 = ((AdvertiseEventArgs) null);
					if (this.ServerData is SysInfoData)
					{
						baseConfig1 = this.ServerData;
						sysInfoData1 = (baseConfig1 as SysInfoData);
						if (sysInfoData1.StateCode != 128)
						{
							sysInfoData1.StateCode = 128;
							advertiseEventArgs1 = new AdvertiseEventArgs (this.GetDataType ().ToString (), ((this.ServerAddress == null) ? IPAddress.Parse ("127.0.0.1") : this.ServerAddress), LECReceiveThread.AdvertiseUpdateSysInfo);
						}
					}
					else
					{
						baseConfig2 = this.ServerData;
						statInfoData1 = (baseConfig2 as StatInfoData);
						if (statInfoData1.JobDataCounter != -1)
						{
							statInfoData1.JobDataCounter = -1;
							advertiseEventArgs1 = new AdvertiseEventArgs (this.GetDataType ().ToString (), ((this.ServerAddress == null) ? IPAddress.Parse ("127.0.0.1") : this.ServerAddress), LECReceiveThread.AdvertiseUpdateStatInfo);
						}
					}
					if (advertiseEventArgs1 != null)
					{
						this.OnAdvertiseEvent (this, advertiseEventArgs1);
					}
				}
				if (this.validateTimer != null)
				{
					bool b2 = this.validateTimer.Change (this.ValidateTimeout, this.ValidateTimeout);
				}
			}
			
		#endregion
	}
	
}

