//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:24:48
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECSession

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using System;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Runtime.InteropServices;
			using System.Threading;
			using System.Xml;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	[ComVisibleAttribute(false)]
	internal class LECEventThread : BaseThread
	
	{
		
		#region Fields
			private string localIPAddress;
			private bool m_bInterrupted;
			public event DataNotify OnDataNotify;
			public event EventNotify OnEventNotify;
			private string remoteIPAddress;
			private int remoteIPPort;
			private TcpClient tcpEventChannel;
			private NetworkStream tcpEventStream;
		#endregion
		
		#region Nested Types
		
			public delegate void DataNotify (uint puiPayloadHigh, uint puiPayloadLow, string pstrData);
			
			public delegate void EventNotify (uint puiPayloadHigh, uint puiPayloadLow);
		#endregion
		
		#region Constructors
		
			public LECEventThread (string localAddress, string remoteAddress, int remotePort)
			
			{
				this.localIPAddress = "";
				this.remoteIPAddress = "";
				this.localIPAddress = localAddress;
				this.remoteIPAddress = remoteAddress;
				this.remoteIPPort = remotePort;
				base.ChildTerminateWait = 1;
			}
			
		#endregion
		
		#region Properties
		
			protected bool Interrupted
			
			{
				get
				{
					return this.m_bInterrupted;
				}
				set
				{
					this.m_bInterrupted = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void Dispose ()
			
			{
				if (this.tcpEventStream != null)
				{
					this.tcpEventStream.Close ();
					this.tcpEventStream = ((NetworkStream) null);
				}
				if (this.tcpEventChannel != null)
				{
					this.tcpEventChannel.Close ();
					this.tcpEventChannel = ((TcpClient) null);
				}
			}
			
			protected override bool ExecuteWorkThread ()
			
			{
				byte[] byteArray1;
				int i1;
				TransmitPacket transmitPacket1;
				int i2;
				byte[] byteArray2;
				byte[] byteArray3;
				int i3;
				EventData eventData1;
				byte[] byteArray4;
				string string1;
				bool b1;
				try
				{
					Logging.Instance.Log (4, "LECEvent.ExecuteWorkThread() - Start Executing Work.");
					if (this.tcpEventStream == null)
					{
						return false;
					}
					if (! this.tcpEventStream.CanRead)
					{
						return false;
					}
					byteArray1 = new byte[TransmitPacket.FixedPacketSize];
					while ((! this.tcpEventStream.DataAvailable) && (! this.Interrupted))
					{
						Thread.Sleep (1);
					}
					if (this.Interrupted)
					{
						this.Interrupted = false;
						return true;
					}
					i1 = this.tcpEventStream.Read (byteArray1, 0, byteArray1.Length);
					Logging.Instance.Log (4, "LECEvent.ExecuteWorkThread() - Read {0} bytes.", byteArray1.Length);
					transmitPacket1 = new TransmitPacket (byteArray1);
					if (transmitPacket1.Opcode < uint.MinValue)
					{
						return false;
					}
					if (transmitPacket1.DataSize == uint.MinValue)
					{
						return false;
					}
					i2 = 0;
					byteArray2 = new byte[transmitPacket1.DataSize];
					while (((long) i2) != ((long) transmitPacket1.DataSize))
					{
						i1 = this.tcpEventStream.Read (byteArray2, i2, ((int) (byteArray2.Length - i2)));
						Logging.Instance.Log (4, "LECEvent.ExecuteWorkThread() - Read {0} bytes.", i1);
						i2 += i1;
					}
					if (((long) i2) != ((long) transmitPacket1.DataSize))
					{
						return false;
					}
					Logging.Instance.Log (4, "LECEvent.ExecuteWorkThread() - Detected an FPGA event.");
					byteArray3 = new byte[EventData.ToBytesSize];
					i3 = 0;
					
				L_0271:
					
					{
					}
					if (i3 < byteArray2.Length)
					{
						Array.Copy (((Array) byteArray2), i3, ((Array) byteArray3), 0, EventData.ToBytesSize);
						eventData1 = new EventData (byteArray3);
						if ((((int) eventData1.PayloadHigh) & 65535) < 65)
						{
							byteArray4 = new byte[(((int) eventData1.PayloadLow) * 4)];
							Array.Copy (((Array) byteArray2), ((long) (i3 + EventData.ToBytesSize)), ((Array) byteArray4), 0L, ((long) (((int) eventData1.PayloadLow) * 4)));
							i3 += (((int) eventData1.PayloadLow) * 4);
							string1 = this.RegistersToXml (byteArray4);
							this.OnDataNotify (eventData1.PayloadHigh, eventData1.PayloadLow, string1);
							Logging.Instance.Log (4, "LECEvent.ExecuteWorkThread() - Data Notify Sent: {0}, {1}, {2}, {3}", ((int) (((int) eventData1.PayloadHigh) & 65535)), ((int) (eventData1.PayloadHigh >> 16)), ((int) (((int) eventData1.PayloadLow) & 65535)), ((int) (eventData1.PayloadLow >> 16)));
						}
						else
						{
							if (eventData1.PayloadHigh == 65)
							{
								Logging.Instance.LogTemp (0, "BeginJobEventReceived", Environment.TickCount);
							}
							if (eventData1.PayloadHigh == 66)
							{
								Logging.Instance.LogTemp (0, "EndJobEventReceived", Environment.TickCount);
							}
							this.OnEventNotify (eventData1.PayloadHigh, eventData1.PayloadLow);
						}
						i3 += EventData.ToBytesSize;
						goto L_0271;
					}
					else
					{
						Logging.Instance.Log (4, "LECEvent.ExecuteWorkThread() - End Executing Work.");
						b1 = true;
					}
				}
				catch (Exception)
				{
					Logging.Instance.Log ("LECEvent.ExecuteWorkThread() - Exception thrown. Abort.");
					b1 = false;
				}
				return b1;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				IPEndPoint iPEndPoint1;
				LingerOption lingerOption1;
				try
				{
					if ((this.localIPAddress == "0.0.0.0") || (this.localIPAddress == ""))
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, 0);
					}
					else
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Parse (this.localIPAddress), 0);
					}
					this.tcpEventChannel = new TcpClient (iPEndPoint1);
					this.tcpEventChannel.Connect (this.remoteIPAddress, this.remoteIPPort);
					this.tcpEventChannel.NoDelay = true;
					lingerOption1 = new LingerOption (false, 1);
					this.tcpEventChannel.LingerState = lingerOption1;
					this.tcpEventStream = this.tcpEventChannel.GetStream ();
				}
				catch (Exception)
				{
					this.Dispose ();
					return false;
				}
				return base.InitializeWorkThread ();
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				this.Interrupted = true;
				base.InterruptWorkThread (pbAbort);
			}
			
			private string RegistersToXml (byte[] regData)
			
			{
				StringWriter stringWriter1;
				XmlTextWriter xmlTextWriter1;
				int i1;
				string string1;
				bool b1;
				bool b2;
				bool b3;
				bool b4;
				bool b5;
				int i2;
				uint uInt32_1;
				uint uInt32_2;
				UInt16 uInt16_1;
				short int16_1;
				int i3;
				int i4;
				stringWriter1 = new StringWriter ();
				xmlTextWriter1 = new XmlTextWriter (((TextWriter) stringWriter1));
				xmlTextWriter1.WriteStartDocument ();
				xmlTextWriter1.WriteWhitespace ("\r\n");
				xmlTextWriter1.WriteStartElement ("Data");
				xmlTextWriter1.WriteAttributeString ("type", "HardwareState");
				xmlTextWriter1.WriteAttributeString ("rev", "1.0");
				i1 = 0;
				goto L_036C;
				
			L_0248:
				
				{
				}
				xmlTextWriter1.WriteWhitespace ("\r\n\t");
				xmlTextWriter1.WriteElementString ("DIO.Control", ("0x" + uInt32_2.ToString ("X")));
				uInt32_2 = ((uint) ((((int) uInt32_1) & 960) >> 6));
				xmlTextWriter1.WriteWhitespace ("\r\n\t");
				xmlTextWriter1.WriteElementString ("DIO.Interlock", ("0x" + uInt32_2.ToString ("X")));
				goto L_0368;
				
			L_02D5:
				
				{
				}
				if (! b1)
				{
					xmlTextWriter1.WriteWhitespace ("\r\n\t");
					if (b2)
					{
						xmlTextWriter1.WriteElementString (string1, ("0x" + BitConverter.ToUInt32 (regData, i1).ToString ("X")));
					}
					else if (b4)
					{
						uInt16_1 = BitConverter.ToUInt16 (regData, i1);
						xmlTextWriter1.WriteElementString (string1, uInt16_1.ToString ());
					}
					else if (b3)
					{
						int16_1 = BitConverter.ToInt16 (regData, i1);
						xmlTextWriter1.WriteElementString (string1, int16_1.ToString ());
					}
					else if (b5)
					{
						i3 = BitConverter.ToInt32 (regData, i1);
						xmlTextWriter1.WriteElementString (string1, i3.ToString ());
					}
				}
				
			L_0368:
				
				{
				}
				i1 += 4;
				
			L_036C:
				
				{
				}
				if (i1 >= regData.Length)
				{
					xmlTextWriter1.WriteWhitespace ("\r\n");
					xmlTextWriter1.WriteEndElement ();
					xmlTextWriter1.WriteEndDocument ();
					return stringWriter1.ToString ();
				}
				string1 = "RegName";
				b1 = false;
				b2 = false;
				b3 = false;
				b4 = false;
				b5 = false;
				i2 = ((i1 == 0) ? 0 : (i1 / 4));
				i4 = i2;
				switch (i4)
				{
					case 17:
					
					{
							string1 = "ServoStatus";
							b2 = true;
							goto L_02D5;
					}
					case 18:
					
					{
							string1 = "XDAC";
							b3 = true;
							goto L_02D5;
					}
					case 19:
					
					{
							string1 = "YDAC";
							b3 = true;
							goto L_02D5;
					}
					case 20:
					
					{
							string1 = "ZDAC";
							b3 = true;
							goto L_02D5;
					}
					case 21:
					
					{
							string1 = "A1DAC";
							b4 = true;
							goto L_02D5;
					}
					case 22:
					
					{
							string1 = "A2DAC";
							b4 = true;
							goto L_02D5;
					}
					case 24:
					
					{
							string1 = "XY2Chan1";
							b3 = true;
							goto L_02D5;
					}
					case 25:
					
					{
							string1 = "XY2Chan2";
							b3 = true;
							goto L_02D5;
					}
					case 26:
					
					{
							string1 = "XY2Chan3";
							b3 = true;
							goto L_02D5;
					}
					case 27:
					
					{
							string1 = "XY2Status";
							b2 = true;
							goto L_02D5;
					}
					case 29:
					
					{
							string1 = "LaserPower";
							b4 = true;
							goto L_02D5;
					}
					case 31:
					
					{
							string1 = "MOTFPosition";
							b5 = true;
							goto L_02D5;
					}
					case 32:
					
					{
							uInt32_1 = BitConverter.ToUInt32 (regData, i1);
							xmlTextWriter1.WriteWhitespace ("\r\n\t");
							xmlTextWriter1.WriteElementString ("DIO", ("0x" + uInt32_1.ToString ("X")));
							uInt32_2 = ((uint) (uInt32_1 & 15));
							xmlTextWriter1.WriteWhitespace ("\r\n\t");
							xmlTextWriter1.WriteElementString ("DIO.IN", ("0x" + uInt32_2.ToString ("X")));
							uInt32_2 = ((uint) ((((int) uInt32_1) & 15360) >> 10));
							xmlTextWriter1.WriteWhitespace ("\r\n\t");
							xmlTextWriter1.WriteElementString ("DIO.OUT", ("0x" + uInt32_2.ToString ("X")));
							uInt32_2 = ((uint) ((((int) uInt32_1) & 114688) >> 14));
							uInt32_2 = ((uint) (uInt32_2 << 1));
							if ((uInt32_1 & 16) == uint.MinValue)
							{
								goto L_0248;
							}
							uInt32_2 = ((uint) (((int) uInt32_2) | 1));
							goto L_0248;
					}
					case 37:
					
					{
							string1 = "XVectCmd";
							b3 = true;
							goto L_02D5;
					}
					case 38:
					
					{
							string1 = "YVectCmd";
							b3 = true;
							goto L_02D5;
					}
					case 39:
					
					{
							string1 = "ZVectCmd";
							b3 = true;
							goto L_02D5;
					}
				}
				b1 = true;
				goto L_02D5;
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				this.Dispose ();
				return base.TerminateWorkThread ();
			}
			
		#endregion
	}
	
}

