//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:24:48
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECSession

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using LanmarkControls.FTP;
			using LanmarkControls.LECBroadcast;
			using Microsoft.Win32;
			using System.Collections;
			using System;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Runtime.InteropServices;
			using System.Threading;
			using System.Xml;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	[ClassInterfaceAttribute(ClassInterfaceType.None)]
	[ProgIdAttribute("LEC.Session")]
	[GuidAttribute("B804C69E-E49B-40dd-AF3F-6D4D73555C06")]
	[ComSourceInterfacesAttribute(((Type) typeof (ILecEvents)))]
	public sealed class Session : ILecSession
	
	{
		
		#region Fields
			public const uint Buffer_Full = 31;
			private readonly string ConfigDefaultPath;
			private string ConfigRemotePath;
			public const uint Error_Aborted = 20;
			public const uint Error_Aborting = 19;
			public const uint Error_Access = 13;
			public const uint Error_AccessDenied = 1;
			public const uint Error_CancelByUser = 18;
			public const uint Error_CommunicationLink = 2;
			public const uint Error_DataExists = 26;
			public const uint Error_DataNotFound = 11;
			public const uint Error_DataUnknown = 15;
			public const uint Error_EventHandling = 16;
			public const uint Error_Exception = 23;
			public const uint Error_InvalidParameter = 9;
			public const uint Error_LaserFile = 27;
			public const uint Error_LicenseAccessDenied = 22;
			public const uint Error_LicenseUnavailable = 21;
			public const uint Error_LocalAccess = 14;
			public const uint Error_Network = 10;
			public const uint Error_NoData = 25;
			public const uint Error_NotAvailable = 17;
			public const uint Error_NotConnected = 3;
			public const uint Error_NotFound = 30;
			public const uint Error_PathNotFound = 12;
			public const uint Error_RemoteAccess = 28;
			public const uint Error_RemoteAPITimeout = 33;
			public const uint Error_RemoteAPIUnavailable = 32;
			public const uint Error_SocketException = 34;
			public const uint Error_StateError = 29;
			public const uint Error_Timeout = 24;
			private ArrayList flashJobFileItemList;
			private readonly string FontDefaultPath;
			private string FontPath;
			private int heartbeatPeriod;
			private uint heartbeatRetry;
			public const int jaDELETE = 0;
			public const int jaRENAME = 1;
			private readonly string JobDefaultExternalPath;
			private readonly string JobDefaultInternalPath;
			private string JobRemoteExternalPath;
			private string JobRemoteInternalPath;
			private string localIPAddress;
			private bool m_bInteractive;
			private bool m_bSessionActive;
			private bool m_bWaitForAbort;
			private Hashtable m_lstParameters;
			private LECAliveThread m_oAliveThread;
			private LECEventThread m_oEventThread;
			private string m_strData;
			private string m_strJobFile;
			private uint m_uiInvokeStatus;
			private FtpConnection moveFileConnection;
			public event ConnectionEventHandler OnConnectionEvent;
			public event DataEventHandler OnDataEvent;
			public event MessageEventHandler OnMessageEvent;
			private string remoteIPAddress;
			private int remoteIPPort;
			private int sendStreamRefCount;
			public const int Storage_Perm = 0;
			public const int Storage_Temp = 1;
			private string strPassword;
			private string strUsername;
			public const uint Success = uint.MinValue;
			private TcpClient tcpDataChannel;
			private NetworkStream tcpDataStream;
			private TcpClient tcpPriorityChannel;
			private NetworkStream tcpPriorityStream;
			private uint transmitTimeout;
			private ArrayList usbJobFileItemList;
		#endregion
		
		#region Nested Types
		
			public enum FileDestination
			
			{
				Drive = 0, 
				JobFlash = 1, 
				JobUSB = 2, 
				Fonts = 3, 
				Config = 4, 
			}
			
		#endregion
		
		#region Constructors
		
			public Session ()
			
			{
				this.flashJobFileItemList = new ArrayList ();
				this.usbJobFileItemList = new ArrayList ();
				this.heartbeatRetry = 5;
				this.heartbeatPeriod = 2;
				this.transmitTimeout = 90;
				this.localIPAddress = "";
				this.remoteIPAddress = "";
				this.strUsername = "EC1000_1_4_2";
				this.strPassword = "fdnTy56-VLnyjUuog-vGhu6";
				this.ConfigDefaultPath = "\\LEC\\Config";
				this.JobDefaultInternalPath = "\\LEC\\Jobs";
				this.JobDefaultExternalPath = "\\USBFlash\\LEC\\Jobs";
				this.FontDefaultPath = "\\LEC\\Fonts";
				this.m_strJobFile = "LocalJob.wlb";
				this.m_strData = "";
				this.m_lstParameters = new Hashtable ();
				this.ConfigRemotePath = this.ConfigDefaultPath;
				this.JobRemoteInternalPath = this.JobDefaultInternalPath;
				this.JobRemoteExternalPath = this.JobDefaultExternalPath;
				this.FontPath = this.FontDefaultPath;
				string string1 = "SOFTWARE\\Alase Technologies\\WinLaseServer\\LEC";
				RegistryKey registryKey1 = Registry.LocalMachine.OpenSubKey (string1);
				if (registryKey1 == null)
				{
					return;
				}
				string string2 = "Keepalive";
				object object1 = registryKey1.GetValue (string2);
				if (object1 != null)
				{
					this.KeepAliveRetryTime = Convert.ToUInt32 (object1);
				}
				if ((this.KeepAliveRetryTime < uint.MinValue) || (this.KeepAliveRetryTime > 240))
				{
					this.KeepAliveRetryTime = 10;
				}
				string2 = "TransmitTimeout";
				object1 = registryKey1.GetValue (string2);
				if (object1 != null)
				{
					this.TransmitTimeout = Convert.ToUInt32 (object1);
				}
				if ((this.TransmitTimeout < 5) || (this.TransmitTimeout > 240))
				{
					this.TransmitTimeout = 200;
				}
				string2 = "TransmitPeriod";
				object1 = registryKey1.GetValue (string2);
				if (object1 != null)
				{
					this.HeartbeatPeriod = Convert.ToInt32 (object1);
				}
				if ((this.HeartbeatPeriod < 1) || (this.HeartbeatPeriod > 60))
				{
					this.HeartbeatPeriod = 5;
				}
			}
			
		#endregion
		
		#region Properties
		
			public int HeartbeatPeriod
			
			{
				get
				{
					return this.heartbeatPeriod;
				}
				set
				{
					this.heartbeatPeriod = value;
				}
			}
			
			
			public string JobFile
			
			{
				get
				{
					return this.m_strJobFile;
				}
			}
			
			
			public uint KeepAliveRetryTime
			
			{
				get
				{
					return this.heartbeatRetry;
				}
				set
				{
					this.heartbeatRetry = value;
				}
			}
			
			
			public string LecFlashJobList
			
			{
				get
				{
					StringWriter stringWriter1 = new StringWriter ();
					XmlTextWriter xmlTextWriter1 = new XmlTextWriter (((TextWriter) stringWriter1));
					xmlTextWriter1.WriteStartElement (((string) null), "LECFlashJobList", ((string) null));
					foreach (FileItem fileItem1 in this.flashJobFileItemList)
					{
						xmlTextWriter1.WriteStartElement (((string) null), "LEC", ((string) null));
						xmlTextWriter1.WriteAttributeString (((string) null), "jobname", ((string) null), Path.GetFileName (fileItem1.FileTitle));
						xmlTextWriter1.WriteEndElement ();
					}
					xmlTextWriter1.WriteEndElement ();
					return stringWriter1.ToString ();
				}
			}
			
			
			public string LecUSBJobList
			
			{
				get
				{
					StringWriter stringWriter1 = new StringWriter ();
					XmlTextWriter xmlTextWriter1 = new XmlTextWriter (((TextWriter) stringWriter1));
					xmlTextWriter1.WriteStartElement (((string) null), "LECUSBJobList", ((string) null));
					foreach (FileItem fileItem1 in this.usbJobFileItemList)
					{
						xmlTextWriter1.WriteStartElement (((string) null), "LEC", ((string) null));
						xmlTextWriter1.WriteAttributeString (((string) null), "jobname", ((string) null), Path.GetFileName (fileItem1.FileTitle));
						xmlTextWriter1.WriteEndElement ();
					}
					xmlTextWriter1.WriteEndElement ();
					return stringWriter1.ToString ();
				}
			}
			
			
			public string LocalIPAddress
			
			{
				get
				{
					return this.localIPAddress;
				}
				set
				{
					this.localIPAddress = value;
				}
			}
			
			
			public string RemoteIPAddress
			
			{
				get
				{
					return this.remoteIPAddress;
				}
				set
				{
					this.remoteIPAddress = value;
				}
			}
			
			
			public int RemoteIPPort
			
			{
				get
				{
					return this.remoteIPPort;
				}
				set
				{
					this.remoteIPPort = value;
				}
			}
			
			
			private int SendStreamRefCount
			
			{
				get
				{
					int i1;
					Session session1 = this;
					lock (session1)
					{
						i1 = this.sendStreamRefCount;
					}
					return i1;
				}
				set
				{
					Session session1 = this;
					lock (session1)
					{
						this.sendStreamRefCount = value;
					}
				}
			}
			
			
			public bool SessionActive
			
			{
				get
				{
					return this.m_bSessionActive;
				}
			}
			
			
			public uint TransmitTimeout
			
			{
				get
				{
					return this.transmitTimeout;
				}
				set
				{
					this.transmitTimeout = value;
				}
			}
			
			
			private bool WaitForAbort
			
			{
				get
				{
					return this.m_bWaitForAbort;
				}
				set
				{
					this.m_bWaitForAbort = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void AbortMoveFile ()
			
			{
				if (this.moveFileConnection != null)
				{
					this.moveFileConnection.Abort ();
				}
			}
			
			private void AliveHandler_OnConnectionNotify (string pstrName, bool pbConnected)
			
			{
				if ((! pbConnected) && this.SessionActive)
				{
					this.m_oAliveThread = ((LECAliveThread) null);
					uint uInt32_1 = this.logoutSession (uint.MinValue);
				}
				if (this.OnConnectionEvent != null)
				{
					this.OnConnectionEvent (pstrName, pbConnected);
				}
			}
			
			public void Dispose ()
			
			{
				if (this.tcpDataStream != null)
				{
					this.tcpDataStream.Close ();
					this.tcpDataStream = ((NetworkStream) null);
				}
				if (this.tcpDataChannel != null)
				{
					this.tcpDataChannel.Close ();
					this.tcpDataChannel = ((TcpClient) null);
				}
				if (this.tcpPriorityStream != null)
				{
					this.tcpPriorityStream.Close ();
					this.tcpPriorityStream = ((NetworkStream) null);
				}
				if (this.tcpPriorityChannel != null)
				{
					this.tcpPriorityChannel.Close ();
					this.tcpPriorityChannel = ((TcpClient) null);
				}
				if (this.m_oEventThread != null)
				{
					bool b1 = this.m_oEventThread.StopThread ();
					this.m_oEventThread = ((LECEventThread) null);
				}
				if (this.m_oAliveThread != null)
				{
					bool b2 = this.m_oAliveThread.StopThread ();
					this.m_oAliveThread = ((LECAliveThread) null);
				}
			}
			
			private void EventHandler_OnDataNotify (uint puiPayloadHigh, uint puiPayloadLow, string pstrData)
			
			{
				Exception exception1;
				string string1;
				try
				{
					if (this.OnDataEvent != null)
					{
						this.OnDataEvent (puiPayloadHigh, puiPayloadLow, pstrData);
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					string1 = exception1.StackTrace.ToString ();
				}
			}
			
			private void EventHandler_OnEventNotify (uint puiPayloadHigh, uint puiPayloadLow)
			
			{
				int i1;
				Exception exception1;
				string string1;
				try
				{
					if (this.OnMessageEvent != null)
					{
						if (AtCommand.ToServerOpcode (((int) (((int) puiPayloadHigh) & 65535))) == LECOpcodes.ApplicationEvent)
						{
							i1 = (((int) (puiPayloadHigh >> 16)) & 65535);
							if (((i1 >= 9000) && (i1 <= 9105)) && (i1 == 9001))
							{
								this.WaitForAbort = false;
							}
						}
						if (! this.WaitForAbort)
						{
							this.OnMessageEvent (puiPayloadHigh, puiPayloadLow);
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					string1 = exception1.StackTrace.ToString ();
				}
			}
			
			private uint internalLoginSession (string localAddress, string remoteAddress, int remotePortNumber, string pstrUsername, string pstrPassword, uint puiTimeout)
			
			{
				string string1;
				int i1;
				SysInfoData sysInfoData1;
				Broadcast broadcast1;
				int i2;
				bool b1;
				BaseConfig baseConfig1;
				uint uInt32_2;
				ArrayList arrayList1;
				int i3;
				BaseConfig baseConfig2;
				IPEndPoint iPEndPoint1;
				LingerOption lingerOption1;
				ArrayList arrayList2;
				int i4;
				BaseConfig baseConfig3;
				IPEndPoint iPEndPoint2;
				LingerOption lingerOption2;
				BaseConfig baseConfig4;
				Exception exception1;
				uint uInt32_3;
				uint uInt32_4;
				Logging.Instance.Log (4, "LECSession.loginSession() called.");
				try
				{
					this.LocalIPAddress = localAddress;
					if (this.m_bSessionActive)
					{
						uint uInt32_5 = this.logoutSession (puiTimeout);
					}
					this.WaitForAbort = false;
					string1 = ((remoteAddress.Length > 0) ? remoteAddress : this.RemoteIPAddress);
					i1 = ((remotePortNumber > 0) ? remotePortNumber : this.RemoteIPPort);
					sysInfoData1 = ((SysInfoData) null);
					broadcast1 = Broadcast.Instance;
					i2 = 0;
					b1 = true;
					if (broadcast1.clientAttachBroadcast ("224.168.100.2", localAddress, 11000, ref i2) > uint.MinValue)
					{
						b1 = false;
					}
					if (b1 && (string1.Length > 0))
					{
						baseConfig1 = ((BaseConfig) null);
						if (broadcast1.getBroadcastData (i2, string1, 1, out baseConfig1) == uint.MinValue)
						{
							sysInfoData1 = (baseConfig1 as SysInfoData);
							string1 = sysInfoData1.Address.ToString ();
							if (sysInfoData1.StateCode != uint.MinValue)
							{
								if (b1)
								{
									uint uInt32_6 = broadcast1.clientDetachBroadcast (i2);
								}
								uInt32_2 = uint.MinValue;
								uInt32_4 = sysInfoData1.StateCode;
								if (uInt32_4 < 32)
								{
									if (uInt32_4 < 8)
									{
										switch ((int) uInt32_4)
										{
											case 1:
											
											{
													return 28;
											}
											case 2:
											case 4:
											
											{
													return 14;
											}
											case 3:
											
											{
													return uInt32_2;
											}
										}
										if (uInt32_4 != 8)
										{
											return uInt32_2;
										}
										else
										{
											return 17;
										}
									}
									if ((uInt32_4 != 16) && (uInt32_4 != 32))
									{
										return uInt32_2;
									}
									else
									{
										return 17;
									}
								}
								if (uInt32_4 < 128)
								{
									if ((uInt32_4 != 64) && (uInt32_4 != 128))
									{
										return uInt32_2;
									}
									else
									{
										return 17;
									}
								}
								if (uInt32_4 == 256)
								{
									return 29;
								}
								else
								{
									if (uInt32_4 == 512)
									{
										uInt32_2 = 30;
									}
									return uInt32_2;
								}
							}
						}
					}
					if (((string1.Length == 0) || (i1 == 0)) && (! this.m_bInteractive))
					{
						if (b1)
						{
							uint uInt32_7 = broadcast1.clientDetachBroadcast (i2);
						}
						return 9;
					}
					else
					{
						if ((string1.Length == 0) || ((i1 == 0) || ((this.strUsername.Length == 0) || (this.strPassword.Length == 0))))
						{
							arrayList1 = new ArrayList ();
							if (b1)
							{
								i3 = 0;
								uint uInt32_8 = broadcast1.getLECServerList (i2, out i3, out arrayList1);
							}
							if (this.PromptConnectComplete (ref string1, ref i1, ref this.strUsername, ref this.strPassword, arrayList1))
							{
								baseConfig2 = ((BaseConfig) null);
								if (sysInfoData1 != null)
								{
									string1 = sysInfoData1.Address.ToString ();
								}
								else if (broadcast1.getBroadcastData (i2, string1, 1, out baseConfig2) == uint.MinValue)
								{
									sysInfoData1 = (baseConfig2 as SysInfoData);
									string1 = sysInfoData1.Address.ToString ();
								}
							}
							else
							{
								if (b1)
								{
									uint uInt32_9 = broadcast1.clientDetachBroadcast (i2);
								}
								return 18;
							}
						}
						if (this.tcpPriorityChannel == null)
						{
							try
							{
								if ((this.localIPAddress == "0.0.0.0") || (this.localIPAddress == ""))
								{
									iPEndPoint1 = new IPEndPoint (IPAddress.Any, 0);
								}
								else
								{
									iPEndPoint1 = new IPEndPoint (IPAddress.Parse (this.localIPAddress), 0);
								}
								this.tcpPriorityChannel = new TcpClient (iPEndPoint1);
								this.tcpPriorityChannel.Connect (string1, ((int) (i1 + 1)));
								lingerOption1 = new LingerOption (false, 1);
								this.tcpPriorityChannel.LingerState = lingerOption1;
							}
							catch
							{
								if (! this.m_bInteractive)
								{
									this.Dispose ();
									if (b1)
									{
										uint uInt32_10 = broadcast1.clientDetachBroadcast (i2);
									}
									return 2;
								}
								else
								{
									arrayList2 = new ArrayList ();
									if (b1)
									{
										i4 = 0;
										uint uInt32_11 = broadcast1.getLECServerList (i2, out i4, out arrayList2);
									}
									if (! this.PromptConnectRetry (ref string1, ref i1, ref this.strUsername, ref this.strPassword, arrayList2))
									{
										this.Dispose ();
										if (b1)
										{
											uint uInt32_12 = broadcast1.clientDetachBroadcast (i2);
										}
										return 18;
									}
									else
									{
										baseConfig3 = ((BaseConfig) null);
										if (sysInfoData1 != null)
										{
											string1 = sysInfoData1.Address.ToString ();
										}
										else if (broadcast1.getBroadcastData (i2, string1, 1, out baseConfig3) == uint.MinValue)
										{
											sysInfoData1 = (baseConfig3 as SysInfoData);
											string1 = sysInfoData1.Address.ToString ();
										}
									}
								}
							}
						}
						if (this.tcpPriorityStream == null)
						{
							try
							{
								this.tcpPriorityStream = this.tcpPriorityChannel.GetStream ();
							}
							catch
							{
								this.Dispose ();
								if (b1)
								{
									uint uInt32_13 = broadcast1.clientDetachBroadcast (i2);
								}
								return 2;
							}
						}
						this.RemoteIPAddress = string1;
						this.RemoteIPPort = i1;
						this.m_bSessionActive = true;
						if (this.tcpDataChannel == null)
						{
							try
							{
								if ((this.localIPAddress == "0.0.0.0") || (this.localIPAddress == ""))
								{
									iPEndPoint2 = new IPEndPoint (IPAddress.Any, 0);
								}
								else
								{
									iPEndPoint2 = new IPEndPoint (IPAddress.Parse (this.localIPAddress), 0);
								}
								this.tcpDataChannel = new TcpClient (iPEndPoint2);
								this.tcpDataChannel.Connect (string1, i1);
								lingerOption2 = new LingerOption (false, 1);
								this.tcpDataChannel.LingerState = lingerOption2;
							}
							catch
							{
								uint uInt32_14 = this.logoutSession (puiTimeout);
								this.Dispose ();
								if (b1)
								{
									uint uInt32_15 = broadcast1.clientDetachBroadcast (i2);
								}
								return 2;
							}
						}
						if (this.tcpDataStream == null)
						{
							try
							{
								this.tcpDataStream = this.tcpDataChannel.GetStream ();
							}
							catch
							{
								uint uInt32_16 = this.logoutSession (puiTimeout);
								this.Dispose ();
								if (b1)
								{
									uint uInt32_17 = broadcast1.clientDetachBroadcast (i2);
								}
								return 2;
							}
						}
						if (this.m_oEventThread == null)
						{
							this.m_oEventThread = new LECEventThread (this.LocalIPAddress, string1, ((int) (i1 + 2)));
							this.m_oEventThread.OnEventNotify += new LECEventThread.EventNotify (this.EventHandler_OnEventNotify);
							this.m_oEventThread.OnDataNotify += new LECEventThread.DataNotify (this.EventHandler_OnDataNotify);
							if (! this.m_oEventThread.StartThread ())
							{
								this.m_oEventThread = ((LECEventThread) null);
								uint uInt32_18 = this.logoutSession (puiTimeout);
								this.Dispose ();
								if (b1)
								{
									uint uInt32_19 = broadcast1.clientDetachBroadcast (i2);
								}
								return 16;
							}
						}
						this.RemoteIPAddress = string1;
						this.RemoteIPPort = i1;
						if (sysInfoData1 == null)
						{
							baseConfig4 = ((BaseConfig) null);
							if (broadcast1.getBroadcastData (i2, string1, 1, out baseConfig4) == uint.MinValue)
							{
								sysInfoData1 = (baseConfig4 as SysInfoData);
							}
						}
						if ((sysInfoData1 != null) && (sysInfoData1.PermStoragePath.Length > 0))
						{
							this.ConfigRemotePath = ("\\" + sysInfoData1.PermStoragePath + this.ConfigDefaultPath);
							this.JobRemoteInternalPath = ("\\" + sysInfoData1.PermStoragePath + this.JobDefaultInternalPath);
						}
						else
						{
							this.ConfigRemotePath = ("\\Disk" + this.ConfigDefaultPath);
							this.JobRemoteInternalPath = ("\\Disk" + this.JobDefaultInternalPath);
						}
						if (this.m_oAliveThread == null)
						{
							this.m_oAliveThread = new LECAliveThread (this.LocalIPAddress, string1, ((int) (i1 + 3)), this.KeepAliveRetryTime, this.HeartbeatPeriod);
							if (this.m_oAliveThread.RetryTime > uint.MinValue)
							{
								this.m_oAliveThread.OnConnectionNotify += new ConnectionNotify (this.AliveHandler_OnConnectionNotify);
								if (! this.m_oAliveThread.StartThread ())
								{
									this.m_oAliveThread = ((LECAliveThread) null);
									uint uInt32_20 = this.logoutSession (puiTimeout);
									this.Dispose ();
									if (b1)
									{
										uint uInt32_21 = broadcast1.clientDetachBroadcast (i2);
									}
									return 16;
								}
							}
							else
							{
								this.m_oAliveThread = ((LECAliveThread) null);
							}
						}
						if (b1)
						{
							uint uInt32_22 = broadcast1.clientDetachBroadcast (i2);
						}
						uInt32_3 = uint.MinValue;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (("LECSession.internalLoginSession() - Exception thrown 0x03d " + exception1.ToString ()));
					uInt32_3 = 23;
				}
				return uInt32_3;
			}
			
			private uint internalLogoutSession (uint puiTimeout)
			
			{
				AtAbort atAbort1;
				Exception exception1;
				Logging.Instance.Log (4, "LECSession.logoutSession() called.");
				try
				{
					if (! this.m_bSessionActive)
					{
						return uint.MinValue;
					}
					else
					{
						this.WaitForAbort = false;
						if ((this.tcpPriorityChannel != null) && (this.tcpPriorityStream != null))
						{
							atAbort1 = new AtAbort ();
							atAbort1.Reason = AbortReason.Terminate;
							uint uInt32_2 = this.sendPriorityData (atAbort1, puiTimeout);
						}
						this.m_bSessionActive = false;
						this.Dispose ();
						this.RemoteIPAddress = "";
						this.RemoteIPPort = 0;
						return uint.MinValue;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (("LECSession.internalLogoutSession() - Exception thrown 0x03d " + exception1.ToString ()));
				}
				return 23;
			}
			
			private uint internalManageJobData (int targetLocation, string pstrCurrentStorageName, string pstrNewStorageName, uint puiActionType)
			
			{
				FtpConnection ftpConnection1;
				string string1;
				Exception exception1;
				int i1;
				try
				{
					ftpConnection1 = new FtpConnection ();
					ftpConnection1.LocalIPAddress = this.LocalIPAddress;
					ftpConnection1.Hostname = this.RemoteIPAddress;
					ftpConnection1.Username = this.strUsername;
					ftpConnection1.Password = this.strPassword;
					ftpConnection1.Connect ();
					if (! ftpConnection1.IsConnected)
					{
						return 10;
					}
					i1 = targetLocation;
					switch (i1)
					{
						case 1:
						
						{
								string1 = this.JobRemoteInternalPath.Replace ("\\", "/");
								goto L_0098;
						}
						case 2:
						
						{
								string1 = this.JobRemoteExternalPath.Replace ("\\", "/");
								goto L_0098;
						}
					}
					string1 = "";
					
				L_0098:
					
					{
					}
					if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
					{
						ftpConnection1.ChangeWorkDir (string1);
						if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
						{
							ftpConnection1.Disconnect ();
							return 12;
						}
					}
					if (puiActionType == uint.MinValue)
					{
						ftpConnection1.Delete (pstrCurrentStorageName);
					}
					else
					{
						ftpConnection1.Rename (pstrCurrentStorageName, pstrNewStorageName);
					}
					ftpConnection1.Disconnect ();
					return uint.MinValue;
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (("Session.requestJobCount() - Exception 0x03d  " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return 23;
			}
			
			private uint internalRequestFixedData (int piDataType, string pstrStorageName, out string pstrData, uint puiTimeout)
			
			{
				BaseConfig baseConfig1;
				string string1;
				string string2;
				uint uInt32_1;
				StreamReader streamReader1;
				Exception exception1;
				Exception exception2;
				uint uInt32_2;
				int i1;
				Logging.Instance.Log (4, "LECSession.requestFixedData() called.");
				pstrData = "";
				try
				{
					baseConfig1 = ((BaseConfig) null);
					i1 = piDataType;
					switch (i1)
					{
						case 1:
						
						{
								baseConfig1 = ((BaseConfig) new SysInfoData ());
								break;
						}
						case 2:
						
						{
								baseConfig1 = ((BaseConfig) new LensConfigData ());
								break;
						}
						case 5:
						
						{
								baseConfig1 = ((BaseConfig) new ControlConfigData ());
								break;
						}
						case 6:
						
						{
								baseConfig1 = ((BaseConfig) new LaserConfigData ());
								break;
						}
						case 10:
						
						{
								baseConfig1 = ((BaseConfig) new AdminConfigData ());
								break;
						}
						case 13:
						
						{
								baseConfig1 = ((BaseConfig) new CorrTableData ());
								break;
						}
						case 15:
						
						{
								baseConfig1 = ((BaseConfig) new UserConfigData ());
								break;
						}
						case 16:
						
						{
								baseConfig1 = ((BaseConfig) new PerformanceMatrixData ());
								break;
						}
					}
					if (baseConfig1 == null)
					{
						return 15;
					}
					if (pstrStorageName == null)
					{
						string1 = ("LEC" + baseConfig1.DefaultFileName);
					}
					else
					{
						string1 = (Path.GetFileNameWithoutExtension (pstrStorageName) + ".xml");
					}
					if (string1.Length > 0)
					{
						string2 = Path.GetTempFileName ();
						uInt32_1 = this.MoveFile (string2, string1, 4, true, true);
						if (uInt32_1 != uint.MinValue)
						{
							File.Delete (string2);
							return uInt32_1;
						}
						else
						{
							try
							{
								streamReader1 = new StreamReader (string2);
								if (streamReader1.BaseStream.Length != ((long) 0))
								{
									this.m_strData = streamReader1.ReadToEnd ();
									streamReader1.Close ();
									File.Delete (string2);
								}
								else
								{
									streamReader1.Close ();
									File.Delete (string2);
									return 14;
								}
							}
							catch
							{
								return 14;
							}
							try
							{
								((IBaseXmlReader) baseConfig1).FromXML (this.m_strData);
								goto L_01A8;
							}
							catch (Exception exception3)
							{
								exception1 = exception3;
								Logging.Instance.Log (4, ("LECSession.internalRequestFixedData() - Exception thrown 0x03d " + exception1.ToString ()));
								return 15;
							}
						}
					}
					this.m_strData = ((IBaseXmlWriter) baseConfig1).ToXML ();
					return 25;
					
				L_01A8:
					
					{
					}
					uInt32_2 = uint.MinValue;
				}
				catch (Exception exception4)
				{
					exception2 = exception4;
					Logging.Instance.Log (4, ("LECSession.internalRequestFixedData() - Exception thrown 0x03d " + exception2.ToString ()));
					uInt32_2 = 23;
				}
				return uInt32_2;
			}
			
			private uint internalSaveJobData (int targetLocation, string pstrStorageName, string pstrJobData, uint puiAccessType, uint puiTimeout)
			
			{
				Logging.Instance.Log (4, "LECSession.saveJobData() called.");
				if (this.WaitForAbort)
				{
					return 19;
				}
				AtJob atJob1 = new AtJob ();
				if (! atJob1.FromXML (pstrJobData))
				{
					return 15;
				}
				byte[] byteArray1 = atJob1.ToBytes ();
				return this.sendBinaryData (4, targetLocation, byteArray1, pstrStorageName, true, puiTimeout);
			}
			
			private uint internalSendBinaryData (int piDataType, int targetLocation, byte[] pstrData, string pstrStorageName, bool pbOverwrite, uint puiTimeout)
			
			{
				string string1;
				string string2;
				BinaryWriter binaryWriter1;
				uint uInt32_1;
				Logging.Instance.Log (4, "LECSession.sendBinaryData() called.");
				try
				{
					string1 = "";
					if (piDataType != 4)
					{
						return 15;
					}
					else
					{
						if ((pstrStorageName == null) || (pstrStorageName.Length == 0))
						{
							string1 = this.m_strJobFile;
						}
						else
						{
							string1 = (Path.GetFileNameWithoutExtension (pstrStorageName) + ".wlb");
						}
						string2 = Path.GetTempFileName ();
						binaryWriter1 = new BinaryWriter (((Stream) File.Open (string2, FileMode.Create)));
						if (binaryWriter1 == null)
						{
							return 14;
						}
						else
						{
							binaryWriter1.Write (pstrData);
							binaryWriter1.Flush ();
							binaryWriter1.Close ();
							uInt32_1 = this.MoveFile (string2, string1, targetLocation, false, pbOverwrite);
							File.Delete (string2);
							return uInt32_1;
						}
					}
				}
				catch (Exception)
				{
				}
				return 23;
			}
			
			private uint internalSendFixedData (BaseConfig poData, string pstrData, string pstrStorageName, bool pbApplyTransforms, uint puiTimeout)
			
			{
				string string1;
				string string2;
				StreamWriter streamWriter1;
				uint uInt32_1;
				AtUpdate atUpdate1;
				Exception exception1;
				uint uInt32_2;
				Logging.Instance.Log (4, "LECSession.sendFixedData() called.");
				try
				{
					if (this.WaitForAbort)
					{
						return 19;
					}
					else
					{
						if (pstrStorageName == null)
						{
							string1 = ("LEC" + poData.DefaultFileName);
							if ((string1 == null) || (string1.Length == 0))
							{
								return 15;
							}
						}
						else
						{
							string1 = (Path.GetFileNameWithoutExtension (pstrStorageName) + ".xml");
						}
						string2 = Path.GetTempFileName ();
						streamWriter1 = File.CreateText (string2);
						if (streamWriter1 == null)
						{
							return 14;
						}
						else
						{
							streamWriter1.Write (pstrData);
							streamWriter1.Flush ();
							streamWriter1.Close ();
							uInt32_1 = this.MoveFile (string2, string1, 4, false, true);
							File.Delete (string2);
							if (uInt32_1 == uint.MinValue)
							{
								atUpdate1 = new AtUpdate ();
								atUpdate1.Add (string1);
								uint uInt32_3 = this.sendPriorityData (atUpdate1.ToBytes (), puiTimeout);
							}
							uInt32_2 = uInt32_1;
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (("LECSession.sendFixedData() - Exception 0x03d  " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
					uInt32_2 = 23;
				}
				return uInt32_2;
			}
			
			private uint internalSendPriorityData (byte[] pbyteData, bool pbWaitForAbort, uint puiTimeout)
			
			{
				ActionData actionData1;
				uint uInt32_1;
				uint uInt32_2;
				uint uInt32_3;
				Logging.Instance.Log (4, "LECSession.sendPriorityData() called.");
				try
				{
					if ((pbyteData == null) || (pbyteData.Length == 0))
					{
						Logging.Instance.Log (4, "LECSession.sendPriorityData() - No data to send. Return success.");
						return uint.MinValue;
					}
					else
					{
						actionData1 = new ActionData ();
						actionData1.ActionContent = pbyteData;
						Logging.Instance.Log (4, "LECSession.sendPriorityData() - Attempt send (priority channel).");
						uInt32_1 = this.sendData (this.tcpPriorityChannel, this.tcpPriorityStream, 3, actionData1.ToBytes (), puiTimeout);
						if ((uInt32_1 == 2) && (this.m_oAliveThread != null))
						{
							bool b1 = this.m_oAliveThread.StopThread ();
							this.m_oAliveThread = ((LECAliveThread) null);
						}
						if (uInt32_1 == 3)
						{
							Logging.Instance.Log ("LECSession.sendPriorityData() - error 0x03d {0}.  Retry connection.", ((int) uInt32_1));
							if (! this.TryConnect (ref this.tcpPriorityChannel, ref this.tcpPriorityStream, this.LocalIPAddress, this.RemoteIPAddress, ((int) (this.RemoteIPPort + 1))))
							{
								Logging.Instance.Log ("LECSession.sendPriorityData() - connection failed.");
							}
							else
							{
								Logging.Instance.Log ("LECSession.sendPriorityData() - Connected.  Re-attempt send.");
								uInt32_1 = this.sendData (this.tcpPriorityChannel, this.tcpPriorityStream, 3, actionData1.ToBytes (), puiTimeout);
							}
						}
						if ((uInt32_1 == uint.MinValue) && pbWaitForAbort)
						{
							Logging.Instance.Log (4, "LECSession.sendPriorityData() - Attempt ACK.");
							uInt32_1 = this.receiveAck (this.tcpPriorityChannel, this.tcpPriorityStream, puiTimeout);
							Logging.Instance.Log (4, "LECSession.sendPriorityData() - Return from ACK 0x03d {0}", ((int) uInt32_1));
						}
						if ((uInt32_1 == uint.MinValue) && pbWaitForAbort)
						{
							Logging.Instance.Log (4, "LECSession.sendPriorityData() - Attempt send (data channel).");
							uInt32_2 = this.sendData (this.tcpDataChannel, this.tcpDataStream, 3, actionData1.ToBytes (), puiTimeout);
							if ((uInt32_2 == 2) || (uInt32_2 == 3))
							{
								Logging.Instance.Log ("LECSession.sendPriorityData() - error 0x03d {0}.  Retry connection.", ((int) uInt32_2));
								if (! this.TryConnect (ref this.tcpDataChannel, ref this.tcpDataStream, this.LocalIPAddress, this.RemoteIPAddress, ((int) (this.RemoteIPPort + 1))))
								{
									Logging.Instance.Log ("LECSession.sendPriorityData() - connection failed.");
								}
								else if (uInt32_2 != 3)
								{
									Logging.Instance.Log ("LECSession.sendPriorityData() - Connected with retrying send.");
								}
								else
								{
									Logging.Instance.Log ("LECSession.sendPriorityData() - Connected.  Re-attempt send.");
									uInt32_2 = this.sendData (this.tcpDataChannel, this.tcpDataStream, 3, actionData1.ToBytes (), puiTimeout);
								}
							}
						}
						uInt32_3 = uInt32_1;
					}
				}
				catch (Exception)
				{
					uInt32_3 = 23;
				}
				return uInt32_3;
			}
			
			private uint internalSendStreamData (uint puiOpcode, byte[] pbyteData, uint puiTimeout)
			
			{
				BaseConfig baseConfig1;
				uint uInt32_1;
				Exception exception1;
				Logging.Instance.Log (4, "LECSession.sendStreamData() called.");
				try
				{
					if (this.WaitForAbort)
					{
						return 19;
					}
					else if ((pbyteData == null) || (pbyteData.Length == 0))
					{
						Logging.Instance.Log (4, "LECSession.sendStreamData() - No data to send. Return success.");
						return uint.MinValue;
					}
					else
					{
						if (puiOpcode == 3)
						{
							baseConfig1 = ((BaseConfig) new ActionData ());
							((ActionData) baseConfig1).ActionContent = pbyteData;
						}
						else
						{
							baseConfig1 = ((BaseConfig) new JobData ());
							((JobData) baseConfig1).JobContent = pbyteData;
						}
						if ((this.m_oEventThread != null) && (! this.m_oEventThread.IsThreadRunning))
						{
							bool b1 = this.m_oEventThread.StartThread ();
						}
						if ((this.m_oAliveThread != null) && (! this.m_oAliveThread.IsThreadRunning))
						{
							bool b2 = this.m_oAliveThread.StartThread ();
						}
						Logging.Instance.Log (4, "LECSession.sendStreamData() - Attempt send (data channel).");
						uInt32_1 = this.sendData (this.tcpDataChannel, this.tcpDataStream, puiOpcode, ((IByteData) baseConfig1).ToBytes (), puiTimeout);
						Logging.Instance.LogTemp (0, "JobSentToNode", Environment.TickCount);
						if (uInt32_1 == 2)
						{
							if (this.m_oAliveThread != null)
							{
								bool b3 = this.m_oAliveThread.StopThread ();
								this.m_oAliveThread = ((LECAliveThread) null);
							}
						}
						else if (uInt32_1 == 3)
						{
							Logging.Instance.Log ("LECSession.sendStreamData() - error 0x03d {0}.  Retry connection.", ((int) uInt32_1));
							if (! this.TryConnect (ref this.tcpDataChannel, ref this.tcpDataStream, this.LocalIPAddress, this.RemoteIPAddress, this.RemoteIPPort))
							{
								Logging.Instance.Log ("LECSession.sendStreamData() - connection failed.");
								return uInt32_1;
							}
							else
							{
								Logging.Instance.Log ("LECSession.sendStreamData() - Connected.  Re-attempt send.");
								uInt32_1 = this.sendData (this.tcpDataChannel, this.tcpDataStream, puiOpcode, ((IByteData) baseConfig1).ToBytes (), puiTimeout);
							}
						}
						return uInt32_1;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (("LECSession.SendStreamData() - Exception 0x03d " + exception1.Message));
				}
				return 23;
			}
			
			private InvokeState Invoke (ThreadStart poStartObject, ArrayList poArguments, ManualResetEvent poSignal, uint puiTimeout)
			
			{
				InvokeState invokeState1 = InvokeState.Completed;
				this.m_uiInvokeStatus = uint.MinValue;
				Thread thread1 = new Thread (poStartObject);
				thread1.IsBackground = true;
				int i1 = thread1.GetHashCode ();
				this.m_lstParameters.Add (i1, poArguments);
				thread1.Start ();
				if (! poSignal.WaitOne (1000, false))
				{
					if ((thread1.ThreadState & ThreadState.Unstarted) != ThreadState.Running)
					{
						return InvokeState.InvokeFailed;
					}
					else if (! poSignal.WaitOne (((int) ((((int) puiTimeout) - 1) * 1000)), false))
					{
						thread1.Abort ();
						invokeState1 = InvokeState.Timeout;
					}
				}
				this.m_lstParameters.Remove (i1);
				return invokeState1;
			}
			
			private void InvokeLoginSession ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				string string1 = ((string) arrayList1[1]);
				string string2 = ((string) arrayList1[2]);
				int i1 = ((int) arrayList1[3]);
				string string3 = ((string) arrayList1[4]);
				string string4 = ((string) arrayList1[5]);
				uint uInt32_1 = ((uint) arrayList1[6]);
				uint uInt32_2 = this.internalLoginSession (string1, string2, i1, string3, string4, uInt32_1);
				this.m_uiInvokeStatus = uInt32_2;
				bool b1 = manualResetEvent1.Set ();
			}
			
			private void InvokeLogoutSession ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				uint uInt32_1 = ((uint) arrayList1[1]);
				uint uInt32_2 = this.internalLogoutSession (uInt32_1);
				this.m_uiInvokeStatus = uInt32_2;
				bool b1 = manualResetEvent1.Set ();
			}
			
			private void InvokeRequestFixedData ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				int i1 = ((int) arrayList1[1]);
				string string1 = ((string) arrayList1[2]);
				uint uInt32_1 = ((uint) arrayList1[3]);
				uint uInt32_2 = this.internalRequestFixedData (i1, string1, out this.m_strData, uInt32_1);
				this.m_uiInvokeStatus = uInt32_2;
				bool b1 = manualResetEvent1.Set ();
			}
			
			private void InvokeSaveJobData ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				int i1 = ((int) arrayList1[1]);
				string string1 = ((string) arrayList1[2]);
				string string2 = ((string) arrayList1[3]);
				uint uInt32_1 = ((uint) arrayList1[4]);
				uint uInt32_2 = ((uint) arrayList1[5]);
				uint uInt32_3 = this.internalSaveJobData (i1, string1, string2, uInt32_1, uInt32_2);
				this.m_uiInvokeStatus = uInt32_3;
				bool b1 = manualResetEvent1.Set ();
			}
			
			private void InvokeSendBinaryData ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				int i1 = ((int) arrayList1[1]);
				int i2 = ((int) arrayList1[2]);
				byte[] byteArray1 = ((byte[]) arrayList1[3]);
				string string1 = ((string) arrayList1[4]);
				bool b1 = ((bool) arrayList1[5]);
				uint uInt32_1 = ((uint) arrayList1[6]);
				uint uInt32_2 = this.internalSendBinaryData (i1, i2, byteArray1, string1, b1, uInt32_1);
				this.m_uiInvokeStatus = uInt32_2;
				bool b2 = manualResetEvent1.Set ();
			}
			
			private void InvokeSendFixedData ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				BaseConfig baseConfig1 = ((BaseConfig) arrayList1[1]);
				string string1 = ((string) arrayList1[2]);
				string string2 = ((string) arrayList1[3]);
				bool b1 = ((bool) arrayList1[4]);
				uint uInt32_1 = ((uint) arrayList1[5]);
				uint uInt32_2 = this.internalSendFixedData (baseConfig1, string1, string2, b1, uInt32_1);
				this.m_uiInvokeStatus = uInt32_2;
				bool b2 = manualResetEvent1.Set ();
			}
			
			private void InvokeSendPriorityData ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				byte[] byteArray1 = ((byte[]) arrayList1[1]);
				bool b1 = ((bool) arrayList1[2]);
				uint uInt32_1 = ((uint) arrayList1[3]);
				uint uInt32_2 = this.internalSendPriorityData (byteArray1, b1, uInt32_1);
				this.m_uiInvokeStatus = uInt32_2;
				bool b2 = manualResetEvent1.Set ();
			}
			
			private void InvokeSendStreamData ()
			
			{
				ArrayList arrayList1 = (this.m_lstParameters[Thread.CurrentThread.GetHashCode ()] as ArrayList);
				ManualResetEvent manualResetEvent1 = ((ManualResetEvent) arrayList1[0]);
				uint uInt32_1 = ((uint) arrayList1[1]);
				byte[] byteArray1 = ((byte[]) arrayList1[2]);
				uint uInt32_2 = ((uint) arrayList1[3]);
				uint uInt32_3 = this.internalSendStreamData (uInt32_1, byteArray1, uInt32_2);
				this.m_uiInvokeStatus = uInt32_3;
				bool b1 = manualResetEvent1.Set ();
			}
			
			public uint loginSession (string localAddress, string remoteAddress, int remotePortNumber, string pstrUsername, string pstrPassword, uint puiTimeout)
			
			{
				ManualResetEvent manualResetEvent1;
				ArrayList arrayList1;
				InvokeState invokeState1;
				uint uInt32_1;
				try
				{
					manualResetEvent1 = new ManualResetEvent (false);
					arrayList1 = new ArrayList ();
					int i1 = arrayList1.Add (manualResetEvent1);
					int i2 = arrayList1.Add (localAddress);
					int i3 = arrayList1.Add (remoteAddress);
					int i4 = arrayList1.Add (remotePortNumber);
					int i5 = arrayList1.Add (pstrUsername);
					int i6 = arrayList1.Add (pstrPassword);
					int i7 = arrayList1.Add (puiTimeout);
					invokeState1 = this.Invoke (new ThreadStart (this.InvokeLoginSession), arrayList1, manualResetEvent1, puiTimeout);
					if (invokeState1 == InvokeState.Timeout)
					{
						return 24;
					}
					else if (invokeState1 == InvokeState.InvokeFailed)
					{
						return this.internalLoginSession (localAddress, remoteAddress, remotePortNumber, pstrUsername, pstrPassword, puiTimeout);
					}
					else
					{
						uInt32_1 = this.m_uiInvokeStatus;
					}
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint loginSession (string localAddress, string remoteAddress, int remotePortNumber, uint puiTimeout)
			
			{
				return this.loginSession (localAddress, remoteAddress, remotePortNumber, "", "", puiTimeout);
			}
			
			public uint logoutSession (uint puiTimeout)
			
			{
				ManualResetEvent manualResetEvent1;
				ArrayList arrayList1;
				InvokeState invokeState1;
				uint uInt32_1;
				try
				{
					manualResetEvent1 = new ManualResetEvent (false);
					arrayList1 = new ArrayList ();
					int i1 = arrayList1.Add (manualResetEvent1);
					int i2 = arrayList1.Add (puiTimeout);
					invokeState1 = this.Invoke (new ThreadStart (this.InvokeLogoutSession), arrayList1, manualResetEvent1, puiTimeout);
					if (invokeState1 == InvokeState.Timeout)
					{
						return 24;
					}
					else if (invokeState1 == InvokeState.InvokeFailed)
					{
						return this.internalLogoutSession (puiTimeout);
					}
					else
					{
						uInt32_1 = this.m_uiInvokeStatus;
					}
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint manageJobData (int targetLocation, string pstrCurrentStorageName, string pstrNewStorageName, uint puiActionType, uint puiTimeout)
			
			{
				uint uInt32_1;
				try
				{
					uInt32_1 = this.internalManageJobData (targetLocation, pstrCurrentStorageName, pstrNewStorageName, puiActionType);
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			private uint MoveFile (string pstrLocal, string pstrRemote, int targetLocation, bool pbDownload, bool pbOverwrite)
			
			{
				string string1;
				FtpConnection ftpConnection1;
				string string2;
				string string3;
				FileItem[] fileItemArray1;
				bool b1;
				FileItem fileItem1;
				bool b2;
				int i1;
				char[] charArray1;
				FileItem[] fileItemArray2;
				int i3;
				i1 = targetLocation;
				switch (i1)
				{
					case 1:
					
					{
							string1 = this.JobRemoteInternalPath;
							goto L_0045;
					}
					case 2:
					
					{
							string1 = this.JobRemoteExternalPath;
							goto L_0045;
					}
					case 3:
					
					{
							string1 = this.FontPath;
							goto L_0045;
					}
					case 4:
					
					{
							string1 = this.ConfigRemotePath;
							goto L_0045;
					}
				}
				return 12;
				
			L_0045:
				
				{
				}
				ftpConnection1 = new FtpConnection ();
				ftpConnection1.LocalIPAddress = this.LocalIPAddress;
				ftpConnection1.Hostname = this.RemoteIPAddress;
				ftpConnection1.Username = this.strUsername;
				ftpConnection1.Password = this.strPassword;
				ftpConnection1.Connect ();
				if (! ftpConnection1.IsConnected)
				{
					return 10;
				}
				else
				{
					this.moveFileConnection = ftpConnection1;
					string2 = string1.Replace ("\\", "/");
					if (string2.CompareTo (ftpConnection1.WorkDir) != 0)
					{
						ftpConnection1.ChangeWorkDir (string2);
						if (string2.CompareTo (ftpConnection1.WorkDir) != 0)
						{
							if (pbDownload)
							{
								ftpConnection1.Disconnect ();
								this.moveFileConnection = ((FtpConnection) null);
								return 12;
							}
							else
							{
								string3 = "";
								ftpConnection1.ChangeWorkDir ("/");
								charArray1 = new char[] { '\u002F' };
								foreach (string string4 in string2.Split (charArray1))
								{
									if (string4.CompareTo ("") != 0)
									{
										ftpConnection1.MakeDir (string4);
										ftpConnection1.ChangeWorkDir (string4);
										string3 = (string3 + "/" + string4);
										if (string3.CompareTo (ftpConnection1.WorkDir) != 0)
										{
											ftpConnection1.Disconnect ();
											this.moveFileConnection = ((FtpConnection) null);
											return 12;
										}
									}
								}
								if (string2.CompareTo (ftpConnection1.WorkDir) != 0)
								{
									ftpConnection1.Disconnect ();
									this.moveFileConnection = ((FtpConnection) null);
									return 12;
								}
							}
						}
					}
					if (ftpConnection1.GetList ())
					{
						fileItemArray1 = ftpConnection1.GetDirectoryListing ();
						if ((fileItemArray1 != null) && (fileItemArray1.Length > 0))
						{
							b1 = false;
							fileItemArray2 = fileItemArray1;
							i3 = 0;
							while (i3 < fileItemArray2.Length)
							{
								fileItem1 = fileItemArray2[i3];
								if (fileItem1.IsDirectory || (fileItem1.FileTitle.CompareTo (pstrRemote) != 0))
								{
									i3++;
									continue;
								}
								b1 = true;
								break;
							}
							if (b1)
							{
								if ((! pbDownload) && (! pbOverwrite))
								{
									ftpConnection1.Disconnect ();
									this.moveFileConnection = ((FtpConnection) null);
									return 26;
								}
							}
							else if (pbDownload)
							{
								ftpConnection1.Disconnect ();
								this.moveFileConnection = ((FtpConnection) null);
								return 11;
							}
						}
						else if (pbDownload)
						{
							ftpConnection1.Disconnect ();
							this.moveFileConnection = ((FtpConnection) null);
							return 11;
						}
					}
					else if (pbDownload)
					{
						ftpConnection1.Disconnect ();
						this.moveFileConnection = ((FtpConnection) null);
						return 11;
					}
					if (pbDownload)
					{
						b2 = ftpConnection1.DownloadFile (pstrRemote, pstrLocal);
					}
					else
					{
						b2 = ftpConnection1.UploadFile (pstrLocal, pstrRemote);
					}
					ftpConnection1.Disconnect ();
					this.moveFileConnection = ((FtpConnection) null);
					if (b2)
					{
						return uint.MinValue;
					}
					else
					{
						return 13;
					}
				}
			}
			
			public uint MoveFileByFTP (int targetLocation, string fileToMove, string storagePath, bool downloadFile, bool overWrite)
			
			{
				uint uInt32_1;
				Logging.Instance.Log (4, "LECSession.MoveFileToLEC() called.");
				try
				{
					uInt32_1 = this.MoveFile (fileToMove, storagePath, targetLocation, downloadFile, overWrite);
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			private bool PromptConnectComplete (ref string pstrHost, ref int piPort, ref string pstrUser, ref string pstrPass, ArrayList plstHostNames, string pstrMessage)
			
			{
				return true;
			}
			
			private bool PromptConnectComplete (ref string pstrHost, ref int piPort, ref string pstrUser, ref string pstrPass, ArrayList plstHostNames)
			
			{
				return this.PromptConnectComplete (ref pstrHost, ref piPort, ref pstrUser, ref pstrPass, plstHostNames, "");
			}
			
			private bool PromptConnectRetry (ref string pstrHost, ref int piPort, ref string pstrUser, ref string pstrPass, ArrayList plstHostNames)
			
			{
				string string1 = "Connection failed.  Validate information and click Connect.";
				pstrUser = "";
				pstrPass = "";
				return this.PromptConnectComplete (ref pstrHost, ref piPort, ref pstrUser, ref pstrPass, plstHostNames, string1);
			}
			
			private uint receiveAck (TcpClient poTcp, NetworkStream poNet, uint puiTimeout)
			
			{
				byte[] byteArray1;
				Exception exception1;
				if (poTcp == null)
				{
					return 3;
				}
				else if (poNet == null)
				{
					return 3;
				}
				else
				{
					try
					{
						if (poNet.CanRead)
						{
							byteArray1 = new byte[4];
							int i1 = poNet.Read (byteArray1, 0, byteArray1.Length);
							return uint.MinValue;
						}
						else
						{
							return 1;
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						string string1 = exception1.Message;
						return 2;
					}
				}
			}
			
			public uint requestFixedData (int piDataType, out string pstrData, uint puiTimeout)
			
			{
				return this.requestFixedData (piDataType, ((string) null), out pstrData, puiTimeout);
			}
			
			public uint requestFixedData (int piDataType, string pstrStorageName, out BaseConfig poData, uint puiTimeout)
			
			{
				string string1;
				LensConfigData lensConfigData1;
				ControlConfigData controlConfigData1;
				LaserConfigData laserConfigData1;
				CorrTableData corrTableData1;
				UserConfigData userConfigData1;
				PerformanceMatrixData performanceMatrixData1;
				poData = ((BaseConfig) null);
				uint uInt32_1 = this.requestFixedData (piDataType, pstrStorageName, out string1, puiTimeout);
				if (uInt32_1 != uint.MinValue)
				{
					return uInt32_1;
				}
				else
				{
					switch (piDataType)
					{
						case 2:
						
						{
								lensConfigData1 = new LensConfigData ();
								lensConfigData1.FromXML (string1);
								poData = ((BaseConfig) lensConfigData1);
								return uint.MinValue;
						}
						case 3:
						case 4:
						case 14:
						
						{
								return uint.MinValue;
						}
						case 5:
						
						{
								controlConfigData1 = new ControlConfigData ();
								controlConfigData1.FromXML (string1);
								poData = ((BaseConfig) controlConfigData1);
								return uint.MinValue;
						}
						case 6:
						
						{
								laserConfigData1 = new LaserConfigData ();
								laserConfigData1.FromXML (string1);
								poData = ((BaseConfig) laserConfigData1);
								return uint.MinValue;
						}
						case 13:
						
						{
								corrTableData1 = new CorrTableData ();
								corrTableData1.FromXML (string1);
								poData = ((BaseConfig) corrTableData1);
								return uint.MinValue;
						}
						case 15:
						
						{
								userConfigData1 = new UserConfigData ();
								userConfigData1.FromXML (string1);
								poData = ((BaseConfig) userConfigData1);
								return uint.MinValue;
						}
						case 16:
						
						{
								performanceMatrixData1 = new PerformanceMatrixData ();
								performanceMatrixData1.FromXML (string1);
								poData = ((BaseConfig) performanceMatrixData1);
								return uint.MinValue;
						}
					}
					return uint.MinValue;
				}
			}
			
			public uint requestFixedData (int piDataType, out BaseConfig poData, uint puiTimeout)
			
			{
				return this.requestFixedData (piDataType, ((string) null), out poData, puiTimeout);
			}
			
			public uint requestFixedData (int piDataType, string pstrStorageName, out string pstrData, uint puiTimeout)
			
			{
				ManualResetEvent manualResetEvent1;
				ArrayList arrayList1;
				InvokeState invokeState1;
				uint uInt32_1;
				pstrData = "";
				try
				{
					manualResetEvent1 = new ManualResetEvent (false);
					arrayList1 = new ArrayList ();
					int i1 = arrayList1.Add (manualResetEvent1);
					int i2 = arrayList1.Add (piDataType);
					int i3 = arrayList1.Add (pstrStorageName);
					int i4 = arrayList1.Add (puiTimeout);
					invokeState1 = this.Invoke (new ThreadStart (this.InvokeRequestFixedData), arrayList1, manualResetEvent1, puiTimeout);
					if (invokeState1 == InvokeState.Timeout)
					{
						pstrData = "";
						return 24;
					}
					else if (invokeState1 == InvokeState.InvokeFailed)
					{
						return this.internalRequestFixedData (piDataType, pstrStorageName, out pstrData, puiTimeout);
					}
					else
					{
						pstrData = this.m_strData;
						uInt32_1 = this.m_uiInvokeStatus;
					}
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint requestJobCount (int targetLocation, out int iJobCount)
			
			{
				FtpConnection ftpConnection1;
				string string1;
				int i1;
				FileItem[] fileItemArray1;
				Exception exception1;
				uint uInt32_1;
				iJobCount = 0;
				try
				{
					ftpConnection1 = new FtpConnection ();
					ftpConnection1.LocalIPAddress = this.LocalIPAddress;
					ftpConnection1.Hostname = this.RemoteIPAddress;
					ftpConnection1.Username = this.strUsername;
					ftpConnection1.Password = this.strPassword;
					ftpConnection1.Connect ();
					if (! ftpConnection1.IsConnected)
					{
						return 10;
					}
					else
					{
						if (targetLocation == 1)
						{
							string1 = this.JobRemoteInternalPath.Replace ("\\", "/");
							this.flashJobFileItemList.Clear ();
						}
						else if (targetLocation != 2)
						{
							return 12;
						}
						else
						{
							string1 = this.JobRemoteExternalPath.Replace ("\\", "/");
							this.usbJobFileItemList.Clear ();
						}
						if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
						{
							ftpConnection1.ChangeWorkDir (string1);
							if (string1.CompareTo (ftpConnection1.WorkDir) != 0)
							{
								ftpConnection1.Disconnect ();
								return 12;
							}
						}
						i1 = 0;
						if (ftpConnection1.GetList ())
						{
							fileItemArray1 = ftpConnection1.GetDirectoryListing ();
							if ((fileItemArray1 != null) && (fileItemArray1.Length > 0))
							{
								foreach (FileItem fileItem1 in fileItemArray1)
								{
									if (! fileItem1.IsDirectory)
									{
										if (targetLocation != 1)
										{
											int i4 = this.usbJobFileItemList.Add (fileItem1);
											i1 = this.usbJobFileItemList.Count;
										}
										else
										{
											int i3 = this.flashJobFileItemList.Add (fileItem1);
											i1 = this.flashJobFileItemList.Count;
										}
									}
								}
							}
						}
						ftpConnection1.Disconnect ();
						iJobCount = i1;
						uInt32_1 = uint.MinValue;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (("Session.requestJobCount() - Exception 0x03d  " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public FileItem requestJobFileItemByIndex (int targetLocation, int iJobIndex)
			
			{
				FileItem fileItem1;
				try
				{
					if (targetLocation == 1)
					{
						if (this.flashJobFileItemList == null)
						{
							return ((FileItem) null);
						}
						else if ((iJobIndex < 0) || ((iJobIndex + 1) > this.flashJobFileItemList.Count))
						{
							return ((FileItem) null);
						}
						else
						{
							return ((FileItem) this.flashJobFileItemList[iJobIndex]);
						}
					}
					if (targetLocation == 2)
					{
						if (this.usbJobFileItemList == null)
						{
							return ((FileItem) null);
						}
						else if ((iJobIndex < 0) || ((iJobIndex + 1) > this.usbJobFileItemList.Count))
						{
							return ((FileItem) null);
						}
						else
						{
							return ((FileItem) this.usbJobFileItemList[iJobIndex]);
						}
					}
					fileItem1 = ((FileItem) null);
				}
				catch (Exception)
				{
					fileItem1 = ((FileItem) null);
				}
				return fileItem1;
			}
			
			public uint requestJobNameList (int targetLocation, out int piJobCount, out string jobList, uint puiTimeout)
			
			{
				int i1;
				uint uInt32_1;
				uint uInt32_2;
				piJobCount = 0;
				jobList = "";
				try
				{
					uInt32_1 = this.requestJobCount (targetLocation, out i1);
					if (uInt32_1 != uint.MinValue)
					{
						return uInt32_1;
					}
					else if (i1 == 0)
					{
						piJobCount = 0;
						jobList = "";
						return uint.MinValue;
					}
					else
					{
						if (targetLocation == 1)
						{
							jobList = this.LecFlashJobList;
						}
						else
						{
							jobList = this.LecUSBJobList;
						}
						piJobCount = i1;
						uInt32_2 = uint.MinValue;
					}
				}
				catch (Exception)
				{
					uInt32_2 = 23;
				}
				return uInt32_2;
			}
			
			public uint saveJobData (int targetLocation, string pstrStorageName, string pstrJobData, uint puiAccessType, uint puiTimeout)
			
			{
				ManualResetEvent manualResetEvent1;
				ArrayList arrayList1;
				InvokeState invokeState1;
				uint uInt32_1;
				try
				{
					manualResetEvent1 = new ManualResetEvent (false);
					arrayList1 = new ArrayList ();
					int i1 = arrayList1.Add (manualResetEvent1);
					int i2 = arrayList1.Add (targetLocation);
					int i3 = arrayList1.Add (pstrStorageName);
					int i4 = arrayList1.Add (pstrJobData);
					int i5 = arrayList1.Add (puiAccessType);
					int i6 = arrayList1.Add (puiTimeout);
					invokeState1 = this.Invoke (new ThreadStart (this.InvokeSaveJobData), arrayList1, manualResetEvent1, puiTimeout);
					if (invokeState1 == InvokeState.Timeout)
					{
						return 24;
					}
					else if (invokeState1 == InvokeState.InvokeFailed)
					{
						return this.internalSaveJobData (targetLocation, pstrStorageName, pstrJobData, puiAccessType, puiTimeout);
					}
					else
					{
						uInt32_1 = this.m_uiInvokeStatus;
					}
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint sendBinaryData (int piDataType, int fileDestination, byte[] pstrData, string pstrStorageName, bool pbOverwrite, uint puiTimeout)
			
			{
				ManualResetEvent manualResetEvent1 = new ManualResetEvent (false);
				ArrayList arrayList1 = new ArrayList ();
				int i1 = arrayList1.Add (manualResetEvent1);
				int i2 = arrayList1.Add (piDataType);
				int i3 = arrayList1.Add (fileDestination);
				int i4 = arrayList1.Add (pstrData);
				int i5 = arrayList1.Add (pstrStorageName);
				int i6 = arrayList1.Add (pbOverwrite);
				int i7 = arrayList1.Add (puiTimeout);
				InvokeState invokeState1 = this.Invoke (new ThreadStart (this.InvokeSendBinaryData), arrayList1, manualResetEvent1, puiTimeout);
				if (invokeState1 == InvokeState.Timeout)
				{
					return 24;
				}
				else if (invokeState1 != InvokeState.InvokeFailed)
				{
					return this.m_uiInvokeStatus;
				}
				else
				{
					return this.internalSendBinaryData (piDataType, fileDestination, pstrData, pstrStorageName, pbOverwrite, puiTimeout);
				}
			}
			
			private uint sendBinaryData (int piDataType, BaseConfig poData, uint puiTimeout)
			
			{
				return this.sendBinaryData (piDataType, 1, ((IByteData) poData).ToBytes (), "", true, puiTimeout);
			}
			
			private uint sendBinaryData (int piDataType, byte[] pstrData, uint puiTimeout)
			
			{
				return this.sendBinaryData (piDataType, 1, pstrData, "", true, puiTimeout);
			}
			
			public uint sendBinaryData (int piDataType, int fileDestination, BaseConfig poData, string pstrStorageName, bool pbOverwrite, uint puiTimeout)
			
			{
				return this.sendBinaryData (piDataType, fileDestination, ((IByteData) poData).ToBytes (), pstrStorageName, pbOverwrite, puiTimeout);
			}
			
			private uint sendData (TcpClient poTcp, NetworkStream poNet, uint puiOpcode, byte[] pbytePacketData, uint puiTimeout)
			
			{
				TransmitPacket transmitPacket1;
				byte[] byteArray1;
				Exception exception1;
				if (pbytePacketData == null)
				{
					return uint.MinValue;
				}
				else if (pbytePacketData.Length == 0)
				{
					return uint.MinValue;
				}
				else if (poTcp == null)
				{
					return 3;
				}
				else if (poNet == null)
				{
					return 3;
				}
				else
				{
					try
					{
						if (poNet.CanWrite)
						{
							transmitPacket1 = new TransmitPacket ();
							transmitPacket1.Address = IPAddress.Parse ("127.0.0.1");
							transmitPacket1.RequestAddress = IPAddress.Parse ("127.0.0.1");
							transmitPacket1.Opcode = puiOpcode;
							transmitPacket1.DataSize = ((uint) pbytePacketData.Length);
							transmitPacket1.Data = pbytePacketData;
							byteArray1 = transmitPacket1.ToBytes ();
							poNet.Write (byteArray1, 0, byteArray1.Length);
							return uint.MinValue;
						}
						else
						{
							return 1;
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						string string1 = exception1.Message;
						return 2;
					}
				}
			}
			
			private uint sendFixedData (BaseConfig poData, string pstrData, string pstrStorageName, bool pbApplyTransforms, uint puiTimeout)
			
			{
				ManualResetEvent manualResetEvent1 = new ManualResetEvent (false);
				ArrayList arrayList1 = new ArrayList ();
				int i1 = arrayList1.Add (manualResetEvent1);
				int i2 = arrayList1.Add (poData);
				int i3 = arrayList1.Add (pstrData);
				int i4 = arrayList1.Add (pstrStorageName);
				int i5 = arrayList1.Add (pbApplyTransforms);
				int i6 = arrayList1.Add (puiTimeout);
				InvokeState invokeState1 = this.Invoke (new ThreadStart (this.InvokeSendFixedData), arrayList1, manualResetEvent1, puiTimeout);
				if (invokeState1 == InvokeState.Timeout)
				{
					return 24;
				}
				else if (invokeState1 != InvokeState.InvokeFailed)
				{
					return this.m_uiInvokeStatus;
				}
				else
				{
					return this.internalSendFixedData (poData, pstrData, pstrStorageName, pbApplyTransforms, puiTimeout);
				}
			}
			
			public uint sendFixedData (string pstrData, string pstrStorageName, bool pbApplyTransforms, uint puiTimeout)
			
			{
				if (this.WaitForAbort)
				{
					return 19;
				}
				BaseConfig baseConfig1 = IdentifyReader.IdentifyConfigurationData (pstrData);
				if (baseConfig1 != null)
				{
					return this.sendFixedData (baseConfig1, pstrData, pstrStorageName, pbApplyTransforms, puiTimeout);
				}
				else
				{
					return 15;
				}
			}
			
			public uint sendFixedData (BaseConfig poData, string pstrStorageName, uint puiTimeout)
			
			{
				if (! this.WaitForAbort)
				{
					return this.sendFixedData (poData, ((IBaseXmlWriter) poData).ToXML (), pstrStorageName, true, puiTimeout);
				}
				else
				{
					return 19;
				}
			}
			
			public uint sendFixedData (BaseConfig poData, uint puiTimeout)
			
			{
				if (! this.WaitForAbort)
				{
					return this.sendFixedData (poData, ((string) null), puiTimeout);
				}
				else
				{
					return 19;
				}
			}
			
			public uint sendFixedData (string pstrData, uint puiTimeout)
			
			{
				if (! this.WaitForAbort)
				{
					return this.sendFixedData (pstrData, ((string) null), puiTimeout);
				}
				else
				{
					return 19;
				}
			}
			
			public uint sendFixedData (string pstrData, string pstrStorageName, uint puiTimeout)
			
			{
				uint uInt32_1;
				try
				{
					uInt32_1 = this.sendFixedData (pstrData, pstrStorageName, true, puiTimeout);
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint sendPriorityData (AtAbort poData)
			
			{
				byte[] byteArray1 = poData.ToBytes ();
				if (poData.Reason == AbortReason.Job)
				{
					this.WaitForAbort = true;
				}
				return this.sendPriorityData (byteArray1, this.WaitForAbort, this.TransmitTimeout);
			}
			
			public uint sendPriorityData (byte[] pbyteData)
			
			{
				return this.sendPriorityData (pbyteData, this.TransmitTimeout);
			}
			
			public uint sendPriorityData (AtAbort poData, uint puiTimeout)
			
			{
				byte[] byteArray1 = poData.ToBytes ();
				if (poData.Reason == AbortReason.Job)
				{
					this.WaitForAbort = true;
				}
				return this.sendPriorityData (byteArray1, this.WaitForAbort, puiTimeout);
			}
			
			public uint sendPriorityData (string pstrData)
			
			{
				AtAbort atAbort1 = new AtAbort ();
				if (! atAbort1.FromXML (pstrData))
				{
					return 15;
				}
				byte[] byteArray1 = atAbort1.ToBytes ();
				if (atAbort1.Reason == AbortReason.Job)
				{
					this.WaitForAbort = true;
				}
				return this.sendPriorityData (byteArray1, this.WaitForAbort, this.TransmitTimeout);
			}
			
			public uint sendPriorityData (string pstrData, uint puiTimeout)
			
			{
				byte[] byteArray1;
				AtPriority atPriority1;
				PriorityIDs priorityIDs1;
				AtAbort atAbort1;
				AtSuspend atSuspend1;
				AtResume atResume1;
				AtRegisters atRegisters1;
				AtInterlocks atInterlocks1;
				AtRestart atRestart1;
				uint uInt32_1;
				PriorityIDs priorityIDs2;
				try
				{
					byteArray1 = new byte[0];
					atPriority1 = new AtPriority ();
					priorityIDs1 = atPriority1.FromXML (pstrData);
					priorityIDs2 = priorityIDs1;
					switch (priorityIDs2)
					{
						case PriorityIDs.Abort:
						
						{
								atAbort1 = new AtAbort ();
								if (! atAbort1.FromXML (pstrData))
								{
									return 15;
								}
								byteArray1 = atAbort1.ToBytes ();
								if (atAbort1.Reason != AbortReason.Job)
								{
									goto L_017F;
								}
								this.WaitForAbort = true;
								goto L_017F;
						}
						case PriorityIDs.Suspend:
						
						{
								atSuspend1 = new AtSuspend ();
								if (! atSuspend1.FromXML (pstrData))
								{
									return 15;
								}
								byteArray1 = atSuspend1.ToBytes ();
								this.WaitForAbort = false;
								goto L_017F;
						}
						case PriorityIDs.Resume:
						
						{
								atResume1 = new AtResume ();
								if (! atResume1.FromXML (pstrData))
								{
									return 15;
								}
								byteArray1 = atResume1.ToBytes ();
								this.WaitForAbort = false;
								goto L_017F;
						}
						case PriorityIDs.Registers:
						
						{
								atRegisters1 = new AtRegisters ();
								if (! atRegisters1.FromXML (pstrData))
								{
									return 15;
								}
								byteArray1 = atRegisters1.ToBytes ();
								this.WaitForAbort = false;
								goto L_017F;
						}
						case PriorityIDs.Interlocks:
						
						{
								atInterlocks1 = new AtInterlocks ();
								if (! atInterlocks1.FromXML (pstrData))
								{
									return 15;
								}
								byteArray1 = atInterlocks1.ToBytes ();
								this.WaitForAbort = false;
								goto L_017F;
						}
						case PriorityIDs.Restart:
						
						{
								atRestart1 = new AtRestart ();
								if (! atRestart1.FromXML (pstrData))
								{
									return 15;
								}
								byteArray1 = atRestart1.ToBytes ();
								this.WaitForAbort = false;
								if (this.OnConnectionEvent != null)
								{
									this.OnConnectionEvent (this.remoteIPAddress, false);
								}
								goto L_017F;
						}
					}
					return 15;
					
				L_017F:
					
					{
					}
					uInt32_1 = this.sendPriorityData (byteArray1, this.WaitForAbort, puiTimeout);
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			private uint sendPriorityData (byte[] pbyteData, bool pbWaitForAbort, uint puiTimeout)
			
			{
				ManualResetEvent manualResetEvent1 = new ManualResetEvent (false);
				ArrayList arrayList1 = new ArrayList ();
				int i1 = arrayList1.Add (manualResetEvent1);
				int i2 = arrayList1.Add (pbyteData);
				int i3 = arrayList1.Add (pbWaitForAbort);
				int i4 = arrayList1.Add (puiTimeout);
				InvokeState invokeState1 = this.Invoke (new ThreadStart (this.InvokeSendPriorityData), arrayList1, manualResetEvent1, puiTimeout);
				if (invokeState1 == InvokeState.Timeout)
				{
					return 24;
				}
				else if (invokeState1 != InvokeState.InvokeFailed)
				{
					return this.m_uiInvokeStatus;
				}
				else
				{
					return this.internalSendPriorityData (pbyteData, pbWaitForAbort, puiTimeout);
				}
			}
			
			public uint sendPriorityData (byte[] pbyteData, uint puiTimeout)
			
			{
				return this.sendPriorityData (pbyteData, false, puiTimeout);
			}
			
			public uint sendStreamData (AtJob poData, uint puiTimeout)
			
			{
				if (this.WaitForAbort)
				{
					return 19;
				}
				byte[] byteArray1 = poData.ToBytes ();
				return this.sendStreamData (byteArray1, puiTimeout);
			}
			
			public uint sendStreamData (byte[] pbyteData, uint puiTimeout)
			
			{
				return this.sendStreamData (4, pbyteData, puiTimeout);
			}
			
			public uint sendStreamData (uint puiOpcode, byte[] pbyteData)
			
			{
				return this.sendStreamData (puiOpcode, pbyteData, this.TransmitTimeout);
			}
			
			public uint sendStreamData (AtJob poData)
			
			{
				if (this.WaitForAbort)
				{
					return 19;
				}
				byte[] byteArray1 = poData.ToBytes ();
				return this.sendStreamData (byteArray1, this.TransmitTimeout);
			}
			
			public uint sendStreamData (byte[] pbyteData)
			
			{
				if (! this.WaitForAbort)
				{
					return this.sendStreamData (pbyteData, this.TransmitTimeout);
				}
				else
				{
					return 19;
				}
			}
			
			public uint sendStreamData (string pstrData, uint puiTimeout)
			
			{
				StringReader stringReader1;
				XmlTextReader xmlTextReader1;
				byte[] byteArray1;
				string string1;
				CorrTableReader corrTableReader1;
				byte[] byteArray2;
				int i1;
				int i2;
				int i3;
				int i4;
				AtJob atJob1;
				uint uInt32_1;
				Logging.Instance.Log (4, "LECSession.sendStreamData() called.");
				try
				{
					if (this.WaitForAbort)
					{
						return 19;
					}
					else
					{
						stringReader1 = new StringReader (pstrData);
						xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
						byteArray1 = ((byte[]) null);
						while (xmlTextReader1.Read ())
						{
							if ((xmlTextReader1.NodeType != XmlNodeType.Element) || (xmlTextReader1.Name != "Data"))
							{
								continue;
							}
							string1 = xmlTextReader1.GetAttribute ("type");
							if (string1.Length > 0)
							{
								if (string1.CompareTo (new CorrTableReader ().Type) != 0)
								{
									if (string1.CompareTo ("JobData") != 0)
									{
										return 15;
									}
									atJob1 = new AtJob ();
									if (atJob1.FromXML (pstrData))
									{
										byteArray1 = atJob1.ToBytes ();
										return this.sendStreamData (4, byteArray1, puiTimeout);
									}
									else
									{
										return 15;
									}
								}
								corrTableReader1 = new CorrTableReader ();
								if (corrTableReader1 != null)
								{
									((IBaseXmlReader) corrTableReader1).FromXML (pstrData);
								}
								byteArray1 = new byte[4];
								i1 = 0;
								byteArray2 = BitConverter.GetBytes (4370);
								Array.Copy (((Array) byteArray2), 0, ((Array) byteArray1), 0, byteArray2.Length);
								byteArray2 = BitConverter.GetBytes (((short) i1));
								Array.Copy (((Array) byteArray2), 0, ((Array) byteArray1), 2, byteArray2.Length);
								byteArray1 = new byte[((corrTableReader1.TotalPoints * 3) * 8)];
								i2 = 0;
								i3 = 0;
								i4 = 0;
								corrTableReader1.ProcessCorrectData (corrTableReader1, i1, ref byteArray1, out i2, ref i3, out i4);
								return this.sendStreamData (13, byteArray1, puiTimeout);
							}
						}
						uInt32_1 = 15;
					}
				}
				catch (Exception)
				{
					uInt32_1 = 23;
				}
				return uInt32_1;
			}
			
			public uint sendStreamData (uint puiOpcode, byte[] pbyteData, uint puiTimeout)
			
			{
				if (this.SendStreamRefCount > 5)
				{
					return 31;
				}
				ManualResetEvent manualResetEvent1 = new ManualResetEvent (false);
				ArrayList arrayList1 = new ArrayList ();
				int i1 = arrayList1.Add (manualResetEvent1);
				int i2 = arrayList1.Add (puiOpcode);
				int i3 = arrayList1.Add (pbyteData);
				int i4 = arrayList1.Add (puiTimeout);
				this.SendStreamRefCount++;
				InvokeState invokeState1 = this.Invoke (new ThreadStart (this.InvokeSendStreamData), arrayList1, manualResetEvent1, puiTimeout);
				this.SendStreamRefCount--;
				if (invokeState1 == InvokeState.Timeout)
				{
					return 24;
				}
				else if (invokeState1 != InvokeState.InvokeFailed)
				{
					return this.m_uiInvokeStatus;
				}
				else
				{
					return this.internalSendStreamData (puiOpcode, pbyteData, puiTimeout);
				}
			}
			
			public uint sendStreamData (string pstrData)
			
			{
				if (this.WaitForAbort)
				{
					return 19;
				}
				AtJob atJob1 = new AtJob ();
				if (! atJob1.FromXML (pstrData))
				{
					return 15;
				}
				byte[] byteArray1 = atJob1.ToBytes ();
				return this.sendStreamData (byteArray1, this.TransmitTimeout);
			}
			
			private bool TryConnect (ref TcpClient poTcp, ref NetworkStream poNet, string localAddress, string remoteAddress, int remotePort)
			
			{
				IPEndPoint iPEndPoint1;
				LingerOption lingerOption1;
				if (poNet != null)
				{
					poNet.Close ();
					poNet = ((NetworkStream) null);
				}
				if (poTcp != null)
				{
					poTcp.Close ();
					poTcp = ((TcpClient) null);
				}
				try
				{
					if ((this.localIPAddress == "0.0.0.0") || (this.localIPAddress == ""))
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, 0);
					}
					else
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Parse (this.localIPAddress), 0);
					}
					poTcp = new TcpClient (iPEndPoint1);
					poTcp.Connect (remoteAddress, remotePort);
					lingerOption1 = new LingerOption (false, 1);
					poTcp.LingerState = lingerOption1;
					poTcp.NoDelay = true;
				}
				catch (Exception)
				{
					return false;
				}
				try
				{
					poNet = poTcp.GetStream ();
				}
				catch (Exception)
				{
					poTcp.Close ();
					poTcp = ((TcpClient) null);
					return false;
				}
				return true;
			}
			
		#endregion
	}
	
}

